/*
 * Created on 2005. 3. 29.
 *
 * Board Table Ʈ ϱ  Bean
 */
package board;

import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.RemoveException;
import javax.naming.NamingException;
import javax.sql.DataSource;

import util.EJBHomeFactory;
import util.HomeFactoryException;

/**
 * Board Entity Bean
 * 
 * @author ٺΰ
 * @since 2005. 3. 30.
 */
public class BoardBean implements EntityBean {
    public Integer num;

    public int hit, memos, mid;

    public String subject, contents, date;

    private Connection con = null;

    private EntityContext ctx;

    /**
     * ο Entity Bean ̺ Ѵ.
     * 
     * @param num
     * @param subject
     * @param contents
     * @param hit
     * @param memos
     * @param mid
     * @return
     * @throws CreateException
     */
    public Integer ejbCreate(Integer num, String subject, String contents,
            Integer hit, Integer memos, Integer mid) throws CreateException {
        setNum(num.intValue());
        setSubject(subject);
        setContents(contents);
        setHit(hit.intValue());
        setMemos(memos.intValue());
        setMid(mid.intValue());

        try {
            String query = "INSERT INTO Board (num, subject, contents, date, hit, memos, mid)"
                    + " VALUES (?, ?, ?, NOW(), ?, ?, ?)";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, getNum());
            pstmt.setString(2, getSubject());
            pstmt.setString(3, getContents());
            pstmt.setInt(4, getHit());
            pstmt.setInt(5, getMemos());
            pstmt.setInt(6, getMid());
            pstmt.executeUpdate();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbCreate() : " + e);
        }

        return num;
    }

    public void ejbPostCreate(Integer num, String subject, String contents,
            Integer hit, Integer memos, Integer mid) throws CreateException {
    }

    /**
     * Primary Key ̺ شϴ Entity  ´.
     * 
     * @param num
     * @return
     * @throws FinderException
     */
    public Integer ejbFindByPrimaryKey(Integer num) throws FinderException {
        Integer result = null;

        try {
            String query = "SELECT num FROM Board WHERE num = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, num.intValue());
            ResultSet rs = pstmt.executeQuery();

            if (rs.next()) {
                result = num;
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbFindByPrimaryKey() : " + e);
        }

        return result;
    }

    /**
     *  ˻  
     * 
     * @param subject
     * @param page
     * @param pagePerRows
     * @return
     * @throws FinderException
     */
    public Collection ejbFindBySubject(String subject, Integer page,
            Integer pagePerRows) throws FinderException {
        Vector data = new Vector(10, 1);
        try {
            String query = "SELECT num FROM Board"
                    + " WHERE subject LIKE ? ORDER BY num DESC LIMIT ?, ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setString(1, "%" + subject + "%");
            pstmt.setInt(2, (page.intValue() - 1) * pagePerRows.intValue());
            pstmt.setInt(3, pagePerRows.intValue());
            ResultSet rs = pstmt.executeQuery();

            while (rs.next()) {
                data.add(new Integer(rs.getInt("num")));
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbFindBySubject() : " + e);
        }

        return data;
    }

    /**
     *  ˻  
     * 
     * @param contents
     * @param page
     * @param pagePerRows
     * @return
     * @throws FinderException
     */
    public Collection ejbFindByContents(String contents, Integer page,
            Integer pagePerRows) throws FinderException {
        Vector data = new Vector(10, 1);
        try {
            String query = "SELECT num FROM Board"
                    + " WHERE subject LIKE ? ORDER BY num DESC LIMIT ?, ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setString(1, "%" + contents + "%");
            pstmt.setInt(2, (page.intValue() - 1) * pagePerRows.intValue());
            pstmt.setInt(3, pagePerRows.intValue());
            ResultSet rs = pstmt.executeQuery();

            while (rs.next()) {
                data.add(new Integer(rs.getInt("num")));
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbFindByContents() : " + e);
        }

        return data;
    }

    /**
     *   ˻  
     * 
     * @param keyword
     * @param page
     * @param pagePerRows
     * @return
     * @throws FinderException
     */
    public Collection ejbFindByKeyword(String keyword, Integer page,
            Integer pagePerRows) throws FinderException {
        Vector data = new Vector(10, 1);
        try {
            String query = "SELECT num FROM Board"
                    + " WHERE subject LIKE ? OR contents LIKE ? ORDER BY num DESC LIMIT ?, ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setString(1, "%" + keyword + "%");
            pstmt.setString(2, "%" + keyword + "%");
            pstmt.setInt(3, (page.intValue() - 1) * pagePerRows.intValue());
            pstmt.setInt(4, pagePerRows.intValue());
            ResultSet rs = pstmt.executeQuery();

            while (rs.next()) {
                data.add(new Integer(rs.getInt("num")));
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbFindByKeyword() : " + e);
        }

        return data;
    }

    /**
     * شϴ   
     * 
     * @param page
     * @param pagePerRows
     * @return
     * @throws FinderException
     */
    public Collection ejbFindByPage(Integer page, Integer pagePerRows)
            throws FinderException {
        Vector data = new Vector(10, 1);
        try {
            String query = "SELECT num FROM Board ORDER BY num DESC LIMIT ?, ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, (page.intValue() - 1) * pagePerRows.intValue());
            pstmt.setInt(2, pagePerRows.intValue());
            ResultSet rs = pstmt.executeQuery();

            while (rs.next()) {
                data.add(new Integer(rs.getInt("num")));
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbFindByPage() : " + e);
        }

        return data;
    }

    /**
     * ü ڵ Ѵ.
     * 
     * @param keyword
     *            ˻
     * @param type
     *            0:ü, 1:˻, 2:˻, 3: ΰ˻
     * @return ü ڵ
     */
    public Integer ejbHomeGetTotalCount(String keyword, Integer type) {
        int rowCount = 0;

        try {
            String query = null;

            switch (type.intValue()) {
            case 0: // ü
                query = "SELECT COUNT(num) FROM Board";
                break;
            case 1: // ˻
                query = "SELECT COUNT(num) FROM Board WHERE subject LIKE '%"
                        + keyword + "%'";
                break;
            case 2: // ˻
                query = "SELECT COUNT(num) FROM Board WHERE contents LIKE '%"
                        + keyword + "%'";
                break;
            case 3: //  ˻
                query = "SELECT COUNT(num) FROM Board WHERE subject LIKE '%"
                        + keyword + "%' OR contents LIKE '%" + keyword + "%'";
                break;
            }
            PreparedStatement pstmt = con.prepareStatement(query);
            ResultSet rs = pstmt.executeQuery();

            while (rs.next()) {
                rowCount = rs.getInt(1);
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbHomeGetTotalCount() : " + e);
        }

        return new Integer(rowCount);
    }

    public void setNum(int num) {
        this.num = new Integer(num);
    }

    public void setSubject(String subject) {
        this.subject = subject;
    }

    public void setContents(String contents) {
        this.contents = contents;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public void setHit(int hit) {
        this.hit = hit;
    }

    public void setMemos(int memos) {
        this.memos = memos;
    }

    public void setMid(int mid) {
        this.mid = mid;
    }

    public int getNum() {
        return num.intValue();
    }

    public String getSubject() {
        return subject;
    }

    public String getContents() {
        return contents;
    }

    public String getDate() {
        return date;
    }

    public int getHit() {
        return hit;
    }

    public int getMemos() {
        return memos;
    }

    public int getMid() {
        return mid;
    }

    /**
     * Bean νϽ Ȱȭ Ų.
     * 
     * @see javax.ejb.EntityBean#ejbActivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbActivate() throws EJBException, RemoteException {
        num = (Integer) ctx.getPrimaryKey();
    }

    /**
     * Bean νϽ  ´.
     * 
     * @see javax.ejb.EntityBean#ejbLoad()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbLoad() throws EJBException, RemoteException {
        try {
            String query = "SELECT subject, contents, date, hit, memos, mid FROM Board WHERE num = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, getNum());
            ResultSet rs = pstmt.executeQuery();

            if (rs.next()) {
                subject = rs.getString("subject");
                contents = rs.getString("contents");
                date = rs.getString("date");
                hit = rs.getInt("hit");
                memos = rs.getInt("memos");
                mid = rs.getInt("mid");
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbLoad() : " + e);
        }
    }

    /**
     * Bean νϽ Ȱȭ Ų.
     * 
     * @see javax.ejb.EntityBean#ejbPassivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbPassivate() throws EJBException, RemoteException {
        num = null;
    }

    /**
     * Bean  ش ̺ 
     * 
     * @see javax.ejb.EntityBean#ejbRemove()
     * @throws javax.ejb.RemoveException
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbRemove() throws RemoveException, EJBException,
            RemoteException {
        try {
            String query = "DELETE FROM Board WHERE num = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, num.intValue());
            pstmt.executeUpdate();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbRemove() : " + e);
        }
    }

    /**
     * Bean νϽ  ش ̺ Ѵ.
     * 
     * @see javax.ejb.EntityBean#ejbStore()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbStore() throws EJBException, RemoteException {
        try {
            String query = "UPDATE Board SET subject = ?, contents = ?, hit = ?, memos = ?, mid = ? WHERE num = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setString(1, subject);
            pstmt.setString(2, contents);
            pstmt.setInt(3, hit);
            pstmt.setInt(4, memos);
            pstmt.setInt(5, mid);
            pstmt.setInt(6, num.intValue());
            pstmt.executeUpdate();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbStore() : " + e);
        }
    }

    /**
     * DB disconnection..
     * 
     * @see javax.ejb.EntityBean#unsetEntityContext()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void unsetEntityContext() throws EJBException, RemoteException {
        this.ctx = null;

        try {
            if (con != null) {
                con.close();
            }
        } catch (SQLException e1) {
            System.out.println("SQLException : \n" + e1.getMessage());
        }
    }

    /**
     * DB Connection...
     * 
     * @see javax.ejb.EntityBean#setEntityContext(javax.ejb.EntityContext)
     * @param ctx
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void setEntityContext(EntityContext ctx) throws EJBException,
            RemoteException {
        this.ctx = ctx;

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            DataSource dataSource = (DataSource) homeFactory
                    .lookUpDataSource("jdbc/BonebaDB");
            con = dataSource.getConnection();
        } catch (HomeFactoryException e) {
            System.out.println("HomeFactoryException : \n" + e.getMessage());
        } catch (NamingException e) {
            System.out.println("NamingException : \n" + e.getMessage());
        } catch (SQLException e) {
            System.out.println("SQLException : \n" + e.getMessage());
        }
    }

}
