/*
 * Created on 2005. 4. 6. 
 */
package board.control;

import java.rmi.RemoteException;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import member.Member;
import member.MemberHome;
import memo.Memo;
import memo.MemoHome;

import sequence.control.SequenceControl;
import sequence.control.SequenceControlHome;
import util.EJBHomeFactory;

import board.Board;
import board.BoardHome;
import board.dto.BoardDTO;
import board.dto.BoardListDTO;
import board.dto.MemoDTO;

/**
 * Խ õ  Ʈ ϱ  Session Bean
 * 
 * @author BABU
 * @since 2005. 4. 6.
 */
public class BoardControlBean implements SessionBean {
    public void ejbCreate() throws CreateException, RemoteException {
    }

    /**
     * BoardDTO , ۳, ȸuid  ԷϿ
     * 
     * @param dto
     * @return 
     * @throws RemoteException
     */
    public boolean write(BoardDTO dto) throws RemoteException {
        boolean flag = false;

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();

            // Primary key 
            int imsi = -1;
            SequenceControlHome sch = (SequenceControlHome) homeFactory
                    .lookUpHome("java:comp/env/ejb/SequenceControlHome",
                            SequenceControlHome.class);
            SequenceControl sc = sch.create();
            imsi = sc.getNextPk("Board");

            // Board Table ڵ Insert
            BoardHome bh = (BoardHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/BoardHome", BoardHome.class);
            Board board = bh.create(new Integer(imsi), dto.getSubject(), dto
                    .getContents(), new Integer(0), new Integer(0),
                    new Integer(dto.getMid()));

            if (board != null) {
                flag = true;
            }
        } catch (Exception e) {
            System.err.println("BoardControlBean write() : " + e);
            return false;
        }

        return flag;
    }

    /**
     * BoardDTO ۹ȣ, ȸuid  ԷϿ
     * 
     * @param dto
     * @return 
     * @throws RemoteException
     */
    public boolean delete(BoardDTO dto) throws RemoteException {
        boolean flag = false;
        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            BoardHome bh = (BoardHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/BoardHome", BoardHome.class);
            Board board = bh.findByPrimaryKey(new Integer(dto.getNum()));

            if (board.getMid() == dto.getMid()) {
                board.remove();

                flag = true;
            } else {
                flag = false;
            }
        } catch (Exception e) {
            System.err.println("BoardControlBean delete() : " + e);
            return false;
        }

        return flag;
    }

    /**
     * BoardDTO ۹ȣ, , ۳, ȸuid  Է..
     * 
     * @param dto
     * @return 
     * @throws RemoteException
     */
    public boolean update(BoardDTO dto) throws RemoteException {
        boolean flag = false;

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();

            // Board Table ڵ Insert
            BoardHome bh = (BoardHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/BoardHome", BoardHome.class);
            Board board = bh.findByPrimaryKey(new Integer(dto.getNum()));

            if (board != null) {
                board.setContents(dto.getContents());
                board.setSubject(dto.getSubject());

                flag = true;
            }
        } catch (Exception e) {
            System.err.println("BoardControlBean update() : " + e);
            return false;
        }

        return flag;
    }

    /**
     * ۳ .
     * 
     * @param num
     *            شϴ ۹ȣ
     * @return BoardDTO
     * @throws RemoteException
     */
    public BoardDTO view(int num) throws RemoteException {
        BoardDTO dto = null;

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();

            // Խù  
            BoardHome bh = (BoardHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/BoardHome", BoardHome.class);
            Board board = bh.findByPrimaryKey(new Integer(num));

            // ۼ  
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);
            Member member = mh.findByPrimaryKey(new Integer(board.getMid()));

            if (board != null) {
                // ȸ 
                int hit = board.getHit() + 1;
                board.setHit(hit);

                // DTO 
                dto = new BoardDTO();
                dto.setContents(board.getContents());
                dto.setDate(board.getDate());
                dto.setEmail(member.getEmail());
                dto.setHit(hit);
                dto.setMemos(board.getMemos());
                dto.setMid(board.getMid());
                dto.setNickname(member.getNickname());
                dto.setNum(num);
                dto.setSubject(board.getSubject());
            } else {
                dto = null;
            }
        } catch (Exception e) {
            System.err.println("BoardControlBean view() : " + e);
            return null;
        }

        return dto;
    }

    /**
     *  Ʈ
     * 
     * @param page
     *             
     * @param pagePerBlock
     *              Row
     * @param keyword
     *            ˻,  null
     * @param searchType
     *            1:˻, 2:˻, 3: ˻
     * @return
     * @throws RemoteException
     */
    public BoardListDTO list(int page, int pagePerBlock, String keyword,
            int searchType) throws RemoteException {
        int totalPage = 0;
        int totalRowCount = 0;
        Vector list = new Vector(10, 1);
        BoardListDTO listDTO = null;

        if (keyword == null) {
            searchType = 0;
        }

        if (page < 1) {
            page = 1;
        }

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();

            // Խù  
            BoardHome bh = (BoardHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/BoardHome", BoardHome.class);
            // ۼ  
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);

            Board board = null;
            Member member = null;

            totalRowCount = bh.getTotalCount(keyword, new Integer(searchType))
                    .intValue();

            if (totalRowCount > 0) {
                // ü  
                totalPage = totalRowCount / pagePerBlock;
                if ((totalRowCount % pagePerBlock) > 0) {
                    totalPage++;
                }

                BoardDTO dto = null;
                Vector imsi = null;
                listDTO = new BoardListDTO();
                int startBlock = -1;

                switch (searchType) {
                case 0: // ü ˻
                    imsi = new Vector(bh.findByPage(new Integer(page),
                            new Integer(pagePerBlock)));

                    for (int i = 0; i < imsi.size(); i++) {
                        board = (Board) imsi.elementAt(i);

                        // ۼ 
                        member = mh
                                .findByPrimaryKey(new Integer(board.getMid()));

                        // BoardDTO 
                        dto = new BoardDTO();
                        dto.setContents(board.getContents());
                        dto.setDate(board.getDate());
                        dto.setEmail(member.getEmail());
                        dto.setHit(board.getHit());
                        dto.setMemos(board.getMemos());
                        dto.setMid(board.getMid());
                        dto.setNickname(member.getNickname());
                        dto.setNum(board.getNum());
                        dto.setSubject(board.getSubject());

                        list.add(dto);
                    }

                    listDTO.setList(list);
                    listDTO.setCurrentPage(page);
                    listDTO.setTotalPage(totalPage);
                    listDTO.setKeyword(keyword);
                    listDTO.setSearchType(searchType);

                    //   
                    if (page > 1) {
                        listDTO.setPrevPage(true);
                    } else {
                        listDTO.setPrevPage(false);
                    }

                    //   
                    if (page < totalPage) {
                        listDTO.setNextPage(true);
                    } else {
                        listDTO.setNextPage(false);
                    }

                    //    
                    startBlock = ((page - 1) / 10) * 10 + 1;
                    listDTO.setStartBlock(startBlock);

                    //    
                    if ((startBlock + 10) > totalPage) {
                        listDTO.setEndBlock(totalPage);
                    } else {
                        listDTO.setEndBlock(startBlock + 10);
                    }
                    break;
                case 1: //  ˻
                    imsi = new Vector(bh.findBySubject(keyword, new Integer(
                            page), new Integer(pagePerBlock)));

                    for (int i = 0; i < imsi.size(); i++) {
                        board = (Board) imsi.elementAt(i);

                        // ۼ 
                        member = mh
                                .findByPrimaryKey(new Integer(board.getMid()));

                        // BoardDTO 
                        dto = new BoardDTO();
                        dto.setContents(board.getContents());
                        dto.setDate(board.getDate());
                        dto.setEmail(member.getEmail());
                        dto.setHit(board.getHit());
                        dto.setMemos(board.getMemos());
                        dto.setMid(board.getMid());
                        dto.setNickname(member.getNickname());
                        dto.setNum(board.getNum());
                        dto.setSubject(board.getSubject());

                        list.add(dto);
                    }

                    listDTO.setList(list);
                    listDTO.setCurrentPage(page);
                    listDTO.setTotalPage(totalPage);
                    listDTO.setKeyword(keyword);
                    listDTO.setSearchType(searchType);

                    //   
                    if (page > 1) {
                        listDTO.setPrevPage(true);
                    } else {
                        listDTO.setPrevPage(false);
                    }

                    //   
                    if (page < totalPage) {
                        listDTO.setNextPage(true);
                    } else {
                        listDTO.setNextPage(false);
                    }

                    //    
                    startBlock = ((page - 1) / 10) * 10 + 1;
                    listDTO.setStartBlock(startBlock);

                    //    
                    if ((startBlock + 10) > totalPage) {
                        listDTO.setEndBlock(totalPage);
                    } else {
                        listDTO.setEndBlock(startBlock + 10);
                    }
                    break;
                case 2: //  ˻
                    imsi = new Vector(bh.findByContents(keyword, new Integer(
                            page), new Integer(pagePerBlock)));

                    for (int i = 0; i < imsi.size(); i++) {
                        board = (Board) imsi.elementAt(i);

                        // ۼ 
                        member = mh
                                .findByPrimaryKey(new Integer(board.getMid()));

                        // BoardDTO 
                        dto = new BoardDTO();
                        dto.setContents(board.getContents());
                        dto.setDate(board.getDate());
                        dto.setEmail(member.getEmail());
                        dto.setHit(board.getHit());
                        dto.setMemos(board.getMemos());
                        dto.setMid(board.getMid());
                        dto.setNickname(member.getNickname());
                        dto.setNum(board.getNum());
                        dto.setSubject(board.getSubject());

                        list.add(dto);
                    }

                    listDTO.setList(list);
                    listDTO.setCurrentPage(page);
                    listDTO.setTotalPage(totalPage);
                    listDTO.setKeyword(keyword);
                    listDTO.setSearchType(searchType);

                    //   
                    if (page > 1) {
                        listDTO.setPrevPage(true);
                    } else {
                        listDTO.setPrevPage(false);
                    }

                    //   
                    if (page < totalPage) {
                        listDTO.setNextPage(true);
                    } else {
                        listDTO.setNextPage(false);
                    }

                    //    
                    startBlock = ((page - 1) / 10) * 10 + 1;
                    listDTO.setStartBlock(startBlock);

                    //    
                    if ((startBlock + 10) > totalPage) {
                        listDTO.setEndBlock(totalPage);
                    } else {
                        listDTO.setEndBlock(startBlock + 10);
                    }
                    break;
                case 3: //   ˻
                    imsi = new Vector(bh.findByKeyword(keyword, new Integer(
                            page), new Integer(pagePerBlock)));

                    for (int i = 0; i < imsi.size(); i++) {
                        board = (Board) imsi.elementAt(i);

                        // ۼ 
                        member = mh
                                .findByPrimaryKey(new Integer(board.getMid()));

                        // BoardDTO 
                        dto = new BoardDTO();
                        dto.setContents(board.getContents());
                        dto.setDate(board.getDate());
                        dto.setEmail(member.getEmail());
                        dto.setHit(board.getHit());
                        dto.setMemos(board.getMemos());
                        dto.setMid(board.getMid());
                        dto.setNickname(member.getNickname());
                        dto.setNum(board.getNum());
                        dto.setSubject(board.getSubject());

                        list.add(dto);
                    }

                    listDTO.setList(list);
                    listDTO.setCurrentPage(page);
                    listDTO.setTotalPage(totalPage);
                    listDTO.setKeyword(keyword);
                    listDTO.setSearchType(searchType);

                    //   
                    if (page > 1) {
                        listDTO.setPrevPage(true);
                    } else {
                        listDTO.setPrevPage(false);
                    }

                    //   
                    if (page < totalPage) {
                        listDTO.setNextPage(true);
                    } else {
                        listDTO.setNextPage(false);
                    }

                    //    
                    startBlock = ((page - 1) / 10) * 10 + 1;
                    listDTO.setStartBlock(startBlock);

                    //    
                    if ((startBlock + 10) > totalPage) {
                        listDTO.setEndBlock(totalPage);
                    } else {
                        listDTO.setEndBlock(startBlock + 10);
                    }
                    break;
                }
            }
        } catch (Exception e) {
            System.err.println("list() : " + e);
            return null;
        }

        return listDTO;
    }

    /**
     * ۴ޱ,  100 . θ۹ȣ, ۼ uid, ޸𳻿 Է
     * 
     * @param dto
     * @return 
     * @throws RemoteException
     */
    public boolean writeMemo(MemoDTO dto) throws RemoteException {
        boolean flag = false;

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();

            // Primary key 
            int imsi = -1;
            SequenceControlHome sch = (SequenceControlHome) homeFactory
                    .lookUpHome("java:comp/env/ejb/SequenceControlHome",
                            SequenceControlHome.class);
            SequenceControl sc = sch.create();
            imsi = sc.getNextPk("Memo");

            // Խù  
            BoardHome bh = (BoardHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/BoardHome", BoardHome.class);
            Board board = bh.findByPrimaryKey(new Integer(dto.getB_num()));

            // Memo Table ڵ Insert
            MemoHome mh = (MemoHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemoHome", MemoHome.class);
            Memo memo = mh.create(new Integer(imsi),
                    new Integer(dto.getB_num()), dto.getMemo(), new Integer(dto
                            .getMid()));

            if (memo != null) {
                board.setMemos(board.getMemos() + 1);
                flag = true;
            }
        } catch (Exception e) {
            System.err.println("BoardControlBean writeMemo() : " + e);
            return false;
        }

        return flag;
    }

    /**
     * ۻ, ۹ȣ, ۼ uid ʿ
     * 
     * @param dto
     * @return 
     * @throws RemoteException
     */
    public boolean deleteMemo(MemoDTO dto) throws RemoteException {
        boolean flag = false;

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();

            // Memo Table ڵ Insert
            MemoHome mh = (MemoHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemoHome", MemoHome.class);
            Memo memo = mh.findByPrimaryKey(new Integer(dto.getNum()));

            if (memo.getMid() == dto.getMid()) {
                memo.remove();
                flag = true;
            }
        } catch (Exception e) {
            System.err.println("BoardControlBean deleteMemo() : " + e);
            return false;
        }

        return flag;
    }

    /**
     * ۸Ʈ, MemoDTO Vector · .
     * 
     * @param num
     * @return ۸Ʈ Vector
     * @throws RemoteException
     */
    public Vector listMemo(int num) throws RemoteException {
        Vector memoList = new Vector(10, 1);

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();

            // Memo Table ڵ Select
            MemoHome mh = (MemoHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemoHome", MemoHome.class);

            // ۼ  
            MemberHome memberHome = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);

            Vector imsi = new Vector(mh.findByB_num(new Integer(num)));

            for (int i = 0; i < imsi.size(); i++) {
                Memo memo = (Memo) imsi.elementAt(i);

                Member member = memberHome.findByPrimaryKey(new Integer(memo
                        .getMid()));

                MemoDTO dto = new MemoDTO();
                dto.setB_num(memo.getB_num());
                dto.setDate(memo.getDate());
                dto.setMemo(memo.getMemo());
                dto.setMid(memo.getMid());
                dto.setNum(memo.getNum());
                dto.setNickname(member.getNickname());
                memoList.add(dto);
            }
        } catch (Exception e) {
            System.err.println("BoardControlBean listMemo() : " + e);
        }

        return memoList;
    }

    /**
     * @see javax.ejb.SessionBean#ejbActivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbActivate() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#ejbPassivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbPassivate() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#ejbRemove()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbRemove() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#setSessionContext(javax.ejb.SessionContext)
     * @param arg0
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void setSessionContext(SessionContext arg0) throws EJBException,
            RemoteException {
    }

}
