/*
 * Created on 2005. 3. 29.
 *
 * Friend Table Ʈ ϱ  Bean
 */
package friend;

import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.RemoveException;
import javax.naming.NamingException;
import javax.sql.DataSource;

import util.EJBHomeFactory;
import util.HomeFactoryException;

/**
 * Friend Entity Bean
 * 
 * @author ٺΰ
 * @since 2005. 3. 30.
 */
public class FriendBean implements EntityBean {
    public Integer uid, f_uid, m_uid;

    private Connection con = null;

    private EntityContext ctx;

    /**
     * ο Entity Bean ̺ Ѵ.
     * 
     * @param uid
     * @param f_uid
     * @param m_uid
     * @return
     * @throws CreateException
     */
    public Integer ejbCreate(Integer uid, Integer f_uid, Integer m_uid)
            throws CreateException {
        setUid(uid.intValue());
        setF_uid(f_uid.intValue());
        setM_uid(m_uid.intValue());

        try {
            String query = "INSERT INTO Friend (uid, f_uid, m_uid) VALUES (?, ?, ?)";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, getUid());
            pstmt.setInt(2, getF_uid());
            pstmt.setInt(3, getM_uid());
            pstmt.executeUpdate();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbCreate() : " + e);
        }

        return uid;
    }

    public void ejbPostCreate(Integer uid, Integer f_uid, Integer m_uid)
            throws CreateException {
    }

    /**
     * Primary Key ̺ شϴ Entity  ´.
     * 
     * @param uid
     * @return
     * @throws FinderException
     */
    public Integer ejbFindByPrimaryKey(Integer uid) throws FinderException {
        try {
            String query = "SELECT f_uid, m_uid FROM Friend WHERE uid = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, uid.intValue());
            ResultSet rs = pstmt.executeQuery();

            if (rs.next()) {
                this.uid = uid;
                f_uid = new Integer(rs.getInt("f_uid"));
                m_uid = new Integer(rs.getInt("m_uid"));
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbFindByPrimaryKey() : " + e);
        }

        return uid;
    }

    /**
     * f_uid ̺ شϴ Entity Vector  ´.
     * 
     * @param f_uid
     * @return
     * @throws FinderException
     */
    public Collection ejbFindByFriend(Integer f_uid) throws FinderException {
        Vector vector = new Vector(10, 1);
        try {
            String query = "SELECT uid FROM Friend WHERE f_uid = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, f_uid.intValue());
            ResultSet rs = pstmt.executeQuery();

            while (rs.next()) {
                vector.add(new Integer(rs.getInt("uid")));
            }

            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbFindByFriend() : " + e);
        }

        return vector;
    }

    public void setUid(int uid) {
        this.uid = new Integer(uid);
    }

    public void setF_uid(int f_uid) {
        this.f_uid = new Integer(f_uid);
    }

    public void setM_uid(int m_uid) {
        this.m_uid = new Integer(m_uid);
    }

    public int getUid() {
        return uid.intValue();
    }

    public int getF_uid() {
        return f_uid.intValue();
    }

    public int getM_uid() {
        return m_uid.intValue();
    }

    /**
     * Bean νϽ Ȱȭ Ų.
     * 
     * @see javax.ejb.EntityBean#ejbActivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbActivate() throws EJBException, RemoteException {
        uid = (Integer) ctx.getPrimaryKey();
    }

    /**
     * Bean νϽ  ´.
     * 
     * @see javax.ejb.EntityBean#ejbLoad()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbLoad() throws EJBException, RemoteException {
        try {
            String query = "SELECT f_uid, m_uid FROM Friend WHERE uid = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, getUid());
            ResultSet rs = pstmt.executeQuery();

            if (rs.next()) {
                f_uid = new Integer(rs.getInt("f_uid"));
                m_uid = new Integer(rs.getInt("m_uid"));
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbLoad() : " + e);
        }
    }

    /**
     * Bean νϽ Ȱȭ Ų.
     * 
     * @see javax.ejb.EntityBean#ejbPassivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbPassivate() throws EJBException, RemoteException {
        uid = null;
    }

    /**
     * Bean  ش ̺ 
     * 
     * @see javax.ejb.EntityBean#ejbRemove()
     * @throws javax.ejb.RemoveException
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbRemove() throws RemoveException, EJBException,
            RemoteException {
        try {
            String query = "DELETE FROM Friend WHERE uid = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, uid.intValue());
            pstmt.executeUpdate();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbRemove() : " + e);
        }
    }

    /**
     * Bean νϽ  ش ̺ Ѵ.
     * 
     * @see javax.ejb.EntityBean#ejbStore()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbStore() throws EJBException, RemoteException {
        try {
            String query = "UPDATE Friend SET f_uid = ?, m_uid = ? WHERE uid = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, getF_uid());
            pstmt.setInt(2, getM_uid());
            pstmt.setInt(3, getUid());
            pstmt.executeUpdate();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("FriendBean.ejbStore() : " + e);
        }
    }

    /**
     * DB disconnection..
     * 
     * @see javax.ejb.EntityBean#unsetEntityContext()
     * @throws EJBException
     * @throws RemoteException
     */
    public void unsetEntityContext() throws EJBException, RemoteException {
        this.ctx = null;

        try {
            if (con != null) {
                con.close();
            }
        } catch (SQLException e1) {
            System.out.println("SQLException : \n" + e1.getMessage());
        }
    }

    /**
     * DB Connection...
     * 
     * @see javax.ejb.EntityBean#setEntityContext(javax.ejb.EntityContext)
     * @param ctx
     * @throws EJBException
     * @throws RemoteException
     */
    public void setEntityContext(EntityContext ctx) throws EJBException,
            RemoteException {
        this.ctx = ctx;

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            DataSource dataSource = (DataSource) homeFactory
                    .lookUpDataSource("jdbc/BonebaDB");
            con = dataSource.getConnection();
        } catch (HomeFactoryException e) {
            System.out.println("HomeFactoryException : \n" + e.getMessage());
        } catch (NamingException e) {
            System.out.println("NamingException : \n" + e.getMessage());
        } catch (SQLException e) {
            System.out.println("SQLException : \n" + e.getMessage());
        }
    }
}
