/*
 * Created on 2005. 3. 28.
 *
 * Member Table Ʈ ϱ  Bean
 */
package member;

import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.RemoveException;
import javax.naming.NamingException;
import javax.sql.DataSource;

import util.EJBHomeFactory;
import util.HomeFactoryException;

/**
 * Member Entity Bean
 * 
 * @author ٺΰ
 * @since 2005. 3. 30.
 */
public class MemberBean implements EntityBean {
    public String email, passwd, nickname, date;

    public Integer uid;

    private Connection con = null;

    private EntityContext ctx;

    public void setUid(int uid) {
        this.uid = new Integer(uid);
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public void setPasswd(String passwd) {
        this.passwd = passwd;
    }

    public void setNickname(String nickname) {
        this.nickname = nickname;
    }

    public void setDate(String date) {
        this.date = date;
    }

    public int getUid() {
        return uid.intValue();
    }

    public String getEmail() {
        return email;
    }

    public String getPasswd() {
        return passwd;
    }

    public String getNickname() {
        return nickname;
    }

    public String getDate() {
        return date;
    }

    /**
     * ü ڵ  ´.
     * 
     * @return
     */
    public Integer ejbHomeGetTotalRowsCount() {
        int rows = 0;

        try {
            String query = "SELECT COUNT(uid) FROM Member";
            PreparedStatement pstmt = con.prepareStatement(query);
            ResultSet rs = pstmt.executeQuery();

            if (rs.next()) {
                rows = rs.getInt(1);
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbHomeTotalRowsCount() : " + e);
        }

        return new Integer(rows);
    }

    /**
     * Primary Key ̺ شϴ Entity  ´.
     * 
     * @param uid
     * @return
     * @throws FinderException
     */
    public Integer ejbFindByPrimaryKey(Integer uid) throws FinderException {
        try {
            String query = "SELECT email, passwd, nickname, date FROM Member WHERE uid = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, uid.intValue());
            ResultSet rs = pstmt.executeQuery();

            if (rs.next()) {
                this.uid = uid;
                email = rs.getString("email");
                passwd = rs.getString("passwd");
                nickname = rs.getString("nickname");
                date = rs.getString("date");
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbFindByPrimaryKey() : " + e);
        }

        return uid;
    }

    /**
     * Email Member ˻
     * 
     * @param email
     * @return
     * @throws FinderException
     */
    public Integer ejbFindByEmail(String email) throws FinderException {
        try {
            String query = "SELECT uid, passwd, nickname, date FROM Member WHERE email = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setString(1, email);
            ResultSet rs = pstmt.executeQuery();

            if (rs.next()) {
                uid = new Integer(rs.getInt("uid"));
                this.email = email;
                nickname = rs.getString("nickname");
                date = rs.getString("date");
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbFindByPrimaryKey() : " + e);
        }

        return uid;
    }

    /**
     * nickname ̺ شϴ Entity Vector  ´.(LIKE ˻)
     * 
     * @param nickname
     * @return
     * @throws FinderException
     */
    public Collection ejbFindByNickname(String nickname) throws FinderException {
        Vector vector = new Vector(10, 1);
        try {
            String query = "SELECT uid FROM Member WHERE nickname LIKE '%"
                    + nickname + "%'";
            PreparedStatement pstmt = con.prepareStatement(query);
            ResultSet rs = pstmt.executeQuery();

            while (rs.next()) {
                vector.add(new Integer(rs.getInt("uid")));
            }

            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbFindByPrimaryKey() : " + e);
        }

        return vector;
    }

    /**
     * ش  ڵ带 ´.
     * 
     * @param page
     * @param pagePerRows
     * @return
     * @throws FinderException
     */
    public Collection ejbFindByPage(int page, int pagePerRows)
            throws FinderException {
        Vector data = new Vector(10, 1);
        try {
            String query = "SELECT uid FROM Member ORDER BY uid DESC LIMIT ?, ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, (page - 1) * pagePerRows);
            pstmt.setInt(2, pagePerRows);
            ResultSet rs = pstmt.executeQuery();

            while (rs.next()) {
                data.add(new Integer(rs.getInt("uid")));
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbFindByPage() : " + e);
        }

        return data;
    }

    /**
     *  ڵ带 ´.
     * 
     * @return
     * @throws FinderException
     */
    public Collection ejbFindByAll() throws FinderException {
        Vector vector = new Vector(10, 1);
        try {
            String query = "SELECT uid FROM Member";
            PreparedStatement pstmt = con.prepareStatement(query);
            ResultSet rs = pstmt.executeQuery();

            while (rs.next()) {
                vector.add(new Integer(rs.getInt("uid")));
            }

            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbFindByAll() : " + e);
        }

        return vector;
    }

    /**
     * ο Entity Bean ̺ Ѵ.
     * 
     * @param uid
     * @param email
     * @param passwd
     * @param nickname
     * @return
     * @throws CreateException
     */
    public Integer ejbCreate(Integer uid, String email, String passwd,
            String nickname) throws CreateException {
        setUid(uid.intValue());
        setEmail(email);
        setPasswd(passwd);
        setNickname(nickname);

        try {
            String query = "INSERT INTO Member (uid, email, passwd, nickname, date) VALUES (?, ?, ?, ?, NOW())";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, uid.intValue());
            pstmt.setString(2, email);
            pstmt.setString(3, passwd);
            pstmt.setString(4, nickname);
            pstmt.executeUpdate();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbCreate() : " + e);
        }

        return uid;
    }

    public void ejbPostCreate(Integer uid, String email, String passwd,
            String nickname) throws CreateException {
    }

    /**
     * Bean νϽ Ȱȭ Ų.
     * 
     * @see javax.ejb.EntityBean#ejbActivate()
     * @throws EJBException
     * @throws RemoteException
     */
    public void ejbActivate() throws EJBException, RemoteException {
        uid = (Integer) ctx.getPrimaryKey();
    }

    /**
     * Bean νϽ  ´.
     * 
     * @see javax.ejb.EntityBean#ejbLoad()
     * @throws EJBException
     * @throws RemoteException
     */
    public void ejbLoad() throws EJBException, RemoteException {
        try {
            String query = "SELECT email, passwd, nickname, date FROM Member WHERE uid = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, uid.intValue());
            ResultSet rs = pstmt.executeQuery();

            if (rs.next()) {
                email = rs.getString("email");
                passwd = rs.getString("passwd");
                nickname = rs.getString("nickname");
                date = rs.getString("date");
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbLoad() : " + e);
        }
    }

    /**
     * Bean νϽ Ȱȭ Ų.
     * 
     * @see javax.ejb.EntityBean#ejbPassivate()
     * @throws EJBException
     * @throws RemoteException
     */
    public void ejbPassivate() throws EJBException, RemoteException {
        uid = null;
    }

    /**
     * Bean  ش ̺ 
     * 
     * @see javax.ejb.EntityBean#ejbRemove()
     * @throws RemoveException
     * @throws EJBException
     * @throws RemoteException
     */
    public void ejbRemove() throws RemoveException, EJBException,
            RemoteException {
        try {
            String query = "DELETE FROM Member WHERE uid = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, uid.intValue());
            pstmt.executeUpdate();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("ejbRemove() : " + e);
        }
    }

    /**
     * Bean νϽ  ش ̺ Ѵ.
     * 
     * @see javax.ejb.EntityBean#ejbStore()
     * @throws EJBException
     * @throws RemoteException
     */
    public void ejbStore() throws EJBException, RemoteException {
        try {
            String query = "UPDATE Member SET email = ?, passwd = ?, nickname = ? WHERE uid = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setString(1, email);
            pstmt.setString(2, passwd);
            pstmt.setString(3, nickname);
            pstmt.setInt(4, uid.intValue());
            pstmt.executeUpdate();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("MemberBean.ejbStore() : " + e);
        }
    }

    /**
     * DB disconnection..
     * 
     * @see javax.ejb.EntityBean#unsetEntityContext()
     * @throws EJBException
     * @throws RemoteException
     */
    public void unsetEntityContext() throws EJBException, RemoteException {
        this.ctx = null;

        try {
            if (con != null) {
                con.close();
            }
        } catch (SQLException e1) {
            System.out.println("SQLException : \n" + e1.getMessage());
        }
    }

    /**
     * DB Connection...
     * 
     * @see javax.ejb.EntityBean#setEntityContext(javax.ejb.EntityContext)
     * @param ctx
     * @throws EJBException
     * @throws RemoteException
     */
    public void setEntityContext(EntityContext ctx) throws EJBException,
            RemoteException {
        this.ctx = ctx;

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            DataSource dataSource = (DataSource) homeFactory
                    .lookUpDataSource("jdbc/BonebaDB");
            con = dataSource.getConnection();
        } catch (HomeFactoryException e) {
            System.out.println("HomeFactoryException : \n" + e.getMessage());
        } catch (NamingException e) {
            System.out.println("NamingException : \n" + e.getMessage());
        } catch (SQLException e) {
            System.out.println("SQLException : \n" + e.getMessage());
        }
    }

}
