/*
 * Created on 2005. 3. 30.
 *
 * ȸ õ  Ʈ ϱ  Session Bean
 */
package member.control;

import java.beans.XMLDecoder;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.rmi.RemoteException;
import java.util.Date;
import java.util.Properties;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;

import sequence.control.SequenceControl;
import sequence.control.SequenceControlHome;
import util.EJBHomeFactory;

import member.Member;
import member.MemberHome;
import member.dto.MemberDTO;

/**
 * Member Control Session Bean
 * 
 * @author ٺΰ
 * @since 2005. 3. 30.
 */
public class MemberControlBean implements SessionBean {
    private String popFolderPath = null;

    public MemberControlBean() {
        try {
            XMLDecoder xmlDecoder = new XMLDecoder(new BufferedInputStream(
                    new FileInputStream("setting.xml")));
            Properties properties = (Properties) xmlDecoder.readObject();
            xmlDecoder.close();

            popFolderPath = properties.getProperty("POPFOLDER_ROOT");
        } catch (FileNotFoundException e) {
            //System.out.println("FileNotFoundException : \n" +
            // e.getMessage());
            popFolderPath = "/PopFolder";
        }
    }

    public void ejbCreate() throws CreateException {
    }

    /**
     * @see javax.ejb.SessionBean#ejbActivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbActivate() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#ejbPassivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbPassivate() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#ejbRemove()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbRemove() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#setSessionContext(javax.ejb.SessionContext)
     * @param arg0
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void setSessionContext(SessionContext arg0) throws EJBException,
            RemoteException {
    }

    /**
     *  Primary Key ´.
     * 
     * @return  Primary Key
     */
    private int getNextPk() {
        int imsi = -1;
        String name = "Member";

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();

            SequenceControlHome sch = (SequenceControlHome) homeFactory
                    .lookUpHome("java:comp/env/ejb/SequenceControlHome",
                            SequenceControlHome.class);
            SequenceControl sc = sch.create();
            imsi = sc.getNextPk(name);
        } catch (Exception ee) {
            System.err.println("getNextPk() ERROR : " + ee);
        }

        return imsi;
    }

    /**
     * ȸ
     * 
     * @param dto
     *            email, passwd, nickname ־ .
     * @return Լ true,  false
     */
    public boolean register(MemberDTO dto) {
        boolean flag = false;

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);
            Member member = mh.create(new Integer(getNextPk()), dto.getEmail(),
                    dto.getPasswd(), dto.getNickname());

            if (member != null) {
                // PopFolder Root 
                File popDir = new File(popFolderPath);

                if (!popDir.exists()) {
                    popDir.mkdir();
                }

                // User PopFolder 
                File userDir = new File(popDir.getAbsolutePath()
                        + File.separator + member.getUid());

                if (!userDir.exists()) {
                    userDir.mkdir();
                }

                flag = true;
            }
        } catch (Exception e) {
            System.err.println("register() : " + e);
            return false;
        }

        return flag;
    }

    /**
     * α
     * 
     * @param dto
     *            email passwd ־.
     * @return  ȸ MemberDTO, н null
     */
    public MemberDTO login(MemberDTO dto) {
        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);
            Member member = mh.findByEmail(dto.getEmail());

            if (member.getPasswd().equals(dto.getPasswd())) {
                dto.setUid(member.getUid());
                dto.setEmail(member.getEmail());
                dto.setNickname(member.getNickname());
                dto.setPasswd("");
            } else {
                dto = null;
            }
        } catch (Exception e) {
            System.err.println("login() : " + e);
            return null;
        }

        return dto;
    }

    /**
     * ȸ
     * 
     * @param dto
     *            uid ־ .
     * @return  ȸ MemberDTO, н null
     */
    public MemberDTO view(MemberDTO dto) {
        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);
            Member member = mh.findByPrimaryKey(new Integer(dto.getUid()));

            if (member != null) {
                dto.setEmail(member.getEmail());
                dto.setNickname(member.getNickname());
                dto.setPasswd("");
            } else {
                dto = null;
            }
        } catch (Exception e) {
            System.err.println("view() : " + e);
            return null;
        }

        return dto;
    }

    /**
     * ȸŻ
     * 
     * @param dto
     *            uid email passwd ־ 
     * @return   true,  false
     */
    public boolean delete(MemberDTO dto) {
        boolean flag = false;
        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);
            Member member = mh.findByPrimaryKey(new Integer(dto.getUid()));

            if (member.getEmail().equals(dto.getEmail())
                    && member.getPasswd().equals(dto.getPasswd())) {
                member.remove();

                // User PopFolder 
                File userDir = new File(popFolderPath + File.separator
                        + member.getUid());

                if (!userDir.exists()) {
                    rmdir(userDir);
                }

                flag = true;
            } else {
                flag = false;
            }
        } catch (Exception e) {
            System.err.println("login() : " + e);
            return false;
        }

        return flag;
    }

    /**
     * Directory ° Ѵ.
     * 
     * @param root
     * @return   
     */
    public boolean rmdir(File root) {
        if (root.exists()) {
            File[] fileList = root.listFiles();

            for (int i = 0; i < fileList.length; i++) {
                if (fileList[i].isFile()) {
                    if (!fileList[i].delete()) {
                        return false;
                    }
                } else {
                    if (!rmdir(fileList[i])) {
                        return false;
                    }
                }
            }
        }

        return root.delete();
    }

    /**
     * ü ȸ
     * 
     * @return ȸ
     */
    public int totalMembers() {
        int memberCount = 0;

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);
            memberCount = mh.getTotalRowsCount().intValue();
        } catch (Exception e) {
            System.err.println("totalMembers() : " + e);
        }

        return memberCount;
    }

    /**
     * ü ȸ 
     * 
     * @return ȸ Ʈ
     */
    public Vector list() {
        Vector vector = new Vector(10, 1);

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);
            Vector imsi = new Vector(mh.findByAll());

            for (int i = 0; i < imsi.size(); i++) {
                Member member = (Member) imsi.elementAt(i);
                MemberDTO dto = new MemberDTO();
                dto.setEmail(member.getEmail());
                dto.setNickname(member.getNickname());
                dto.setUid(member.getUid());
                vector.add(dto);
            }
        } catch (Exception e) {
            System.err.println("list() : " + e);
            return null;
        }

        return vector;
    }

    /**
     * ش  ȸ
     * 
     * @param page
     *            
     * @param pagePerRow
     *              ȸ
     * @return ȸ Ʈ
     */
    public Vector list(int page, int pagePerRow) {
        Vector vector = new Vector(10, 1);

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);
            Vector imsi = new Vector(mh.findByPage(page, pagePerRow));

            for (int i = 0; i < imsi.size(); i++) {
                Member member = (Member) imsi.elementAt(i);
                MemberDTO dto = new MemberDTO();
                dto.setEmail(member.getEmail());
                dto.setNickname(member.getNickname());
                dto.setUid(member.getUid());
                vector.add(dto);
            }
        } catch (Exception e) {
            System.err.println("list() : " + e);
            return null;
        }

        return vector;
    }

    /**
     * ȸ 
     * 
     * @param dto
     * @return  ȸ
     */
    public MemberDTO update(MemberDTO dto) {
        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);
            Member member = mh.findByPrimaryKey(new Integer(dto.getUid()));

            if (member != null) {
                member.setEmail(dto.getEmail());
                member.setNickname(dto.getNickname());
                member.setPasswd(dto.getPasswd());
                dto.setPasswd("");
            } else {
                dto = null;
            }
        } catch (Exception e) {
            System.err.println("update() : " + e);
            return null;
        }

        return dto;
    }

    /**
     * ȸ  ..
     * 
     * @param email
     *            ȸ̸ Vector
     * @param admin
     * @param title
     * @param contents
     */
    public void sendMail(Vector email, String admin, String title,
            String contents) {
        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            Session se = homeFactory
                    .lookUpSession("java:comp/env/mail/BonebaSession");

            Properties props = se.getProperties();
            props.put("mail.from", admin);

            Message msg = new MimeMessage(se);
            msg.setSubject(title);
            msg.setSentDate(new Date());
            msg.setFrom();
            msg.setText(contents);

            for (int i = 0; i < email.size(); i++) {
                String to = (String) email.elementAt(i);
                msg.setRecipients(Message.RecipientType.TO, InternetAddress
                        .parse(to, false));
                Transport.send(msg);
            }
        } catch (Exception e) {
            System.err.println("sendMail() : " + e);
        }
    }

    /**
     * ڿ ȸ , ȸ uid Integer Vector· ѱ.
     * 
     * @param vector
     * @return
     */
    public boolean deleteByAdmin(Vector vector) {
        boolean flag = false;
        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);

            for (int i = 0; i < vector.size(); i++) {
                Member member = mh.findByPrimaryKey((Integer) vector
                        .elementAt(i));

                member.remove();

                // User PopFolder 
                File userDir = new File(popFolderPath + File.separator
                        + member.getUid());

                if (!userDir.exists()) {
                    rmdir(userDir);
                }
            }

            flag = true;
        } catch (Exception e) {
            System.err.println("deleteByAdmin() : " + e);
            return false;
        }

        return flag;
    }
}
