/*
 * Created on 2005. 3. 30.
 *
 * Memo Table Ʈ ϱ  Bean
 */
package memo;

import java.rmi.RemoteException;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Collection;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.RemoveException;
import javax.naming.NamingException;
import javax.sql.DataSource;

import util.EJBHomeFactory;
import util.HomeFactoryException;

/**
 * Memo Entity Bean
 * 
 * @author ٺΰ
 * @since 2005. 3. 30.
 */
public class MemoBean implements EntityBean {
    public Integer num;

    public int b_num, mid;

    public String memo, date;

    private Connection con = null;

    private EntityContext ctx;

    /**
     * ο Entity Bean ̺ Ѵ.
     * 
     * @param num
     * @param b_num
     * @param memo
     * @param mid
     * @return
     * @throws CreateException
     */
    public Integer ejbCreate(Integer num, Integer b_num, String memo,
            Integer mid) throws CreateException {
        setNum(num.intValue());
        setB_num(b_num.intValue());
        setMemo(memo);
        setMid(mid.intValue());

        try {
            String query = "INSERT INTO Memo (num, b_num, memo, date, mid)"
                    + " VALUES (?, ?, ?, NOW(), ?)";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, getNum());
            pstmt.setInt(2, getB_num());
            pstmt.setString(3, getMemo());
            pstmt.setInt(4, getMid());
            pstmt.executeUpdate();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("Memo ejbCreate() : " + e);
        }

        return num;
    }

    public void ejbPostCreate(Integer num, Integer b_num, String memo,
            Integer mid) throws CreateException {
    }

    /**
     * Primary Key ̺ شϴ Entity  ´.
     * 
     * @param num
     * @return Memo
     * @throws FinderException
     */
    public Integer ejbFindByPrimaryKey(Integer num) throws FinderException {
        Integer result = null;

        try {
            String query = "SELECT num FROM Memo WHERE num = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, num.intValue());
            ResultSet rs = pstmt.executeQuery();

            if (rs.next()) {
                result = num;
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("Memo ejbFindByPrimaryKey() : " + e);
        }

        return result;
    }

    /**
     * ش Խù ޸ ´.
     * 
     * @param b_num
     * @return Memo Vector
     * @throws FinderException
     */
    public Collection ejbFindByB_num(Integer b_num) throws FinderException {
        Vector data = new Vector(10, 1);
        try {
            String query = "SELECT num FROM Memo WHERE b_num = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, b_num.intValue());
            ResultSet rs = pstmt.executeQuery();

            while (rs.next()) {
                data.add(new Integer(rs.getInt("num")));
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("Memo ejbFindByB_num() : " + e);
        }

        return data;
    }

    /**
     * @return Returns the b_num.
     */
    public int getB_num() {
        return b_num;
    }

    /**
     * @param b_num
     *            The b_num to set.
     */
    public void setB_num(int b_num) {
        this.b_num = b_num;
    }

    /**
     * @return Returns the date.
     */
    public String getDate() {
        return date;
    }

    /**
     * @param date
     *            The date to set.
     */
    public void setDate(String date) {
        this.date = date;
    }

    /**
     * @return Returns the memo.
     */
    public String getMemo() {
        return memo;
    }

    /**
     * @param memo
     *            The memo to set.
     */
    public void setMemo(String memo) {
        this.memo = memo;
    }

    /**
     * @return Returns the mid.
     */
    public int getMid() {
        return mid;
    }

    /**
     * @param mid
     *            The mid to set.
     */
    public void setMid(int mid) {
        this.mid = mid;
    }

    /**
     * @return Returns the num.
     */
    public int getNum() {
        return num.intValue();
    }

    /**
     * @param num
     *            The num to set.
     */
    public void setNum(int num) {
        this.num = new Integer(num);
    }

    /**
     * Bean νϽ Ȱȭ Ų.
     * 
     * @see javax.ejb.EntityBean#ejbActivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbActivate() throws EJBException, RemoteException {
        num = (Integer) ctx.getPrimaryKey();
    }

    /**
     * Bean νϽ  ´.
     * 
     * @see javax.ejb.EntityBean#ejbLoad()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbLoad() throws EJBException, RemoteException {
        try {
            String query = "SELECT b_num, memo, date, mid FROM Memo WHERE num = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, getNum());
            ResultSet rs = pstmt.executeQuery();

            if (rs.next()) {
                b_num = rs.getInt("b_num");
                memo = rs.getString("memo");
                date = rs.getString("date");
                mid = rs.getInt("mid");
            }
            rs.close();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("Memo ejbLoad() : " + e);
        }
    }

    /**
     * Bean νϽ Ȱȭ Ų.
     * 
     * @see javax.ejb.EntityBean#ejbPassivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbPassivate() throws EJBException, RemoteException {
        num = null;
    }

    /**
     * Bean  ش ̺ 
     * 
     * @see javax.ejb.EntityBean#ejbRemove()
     * @throws javax.ejb.RemoveException
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbRemove() throws RemoveException, EJBException,
            RemoteException {
        try {
            String query = "DELETE FROM Memo WHERE num = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, num.intValue());
            pstmt.executeUpdate();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("Memo ejbRemove() : " + e);
        }
    }

    /**
     * Bean νϽ  ش ̺ Ѵ.
     * 
     * @see javax.ejb.EntityBean#ejbStore()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbStore() throws EJBException, RemoteException {
        try {
            String query = "UPDATE Memo SET b_num = ?, memo = ?, mid = ? WHERE num = ?";
            PreparedStatement pstmt = con.prepareStatement(query);
            pstmt.setInt(1, b_num);
            pstmt.setString(2, memo);
            pstmt.setInt(3, mid);
            pstmt.setInt(4, num.intValue());
            pstmt.executeUpdate();
            pstmt.close();
        } catch (Exception e) {
            System.err.println("Memo ejbStore() : " + e);
        }
    }

    /**
     * DB disconnection..
     * 
     * @see javax.ejb.EntityBean#unsetEntityContext()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void unsetEntityContext() throws EJBException, RemoteException {
        this.ctx = null;

        try {
            if (con != null) {
                con.close();
            }
        } catch (SQLException e1) {
            System.out.println("Memo SQLException : \n" + e1.getMessage());
        }
    }

    /**
     * DB Connection...
     * 
     * @see javax.ejb.EntityBean#setEntityContext(javax.ejb.EntityContext)
     * @param ctx
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void setEntityContext(EntityContext ctx) throws EJBException,
            RemoteException {
        this.ctx = ctx;

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            DataSource dataSource = (DataSource) homeFactory
                    .lookUpDataSource("jdbc/BonebaDB");
            con = dataSource.getConnection();
        } catch (HomeFactoryException e) {
            System.out.println("Memo HomeFactoryException : \n"
                    + e.getMessage());
        } catch (NamingException e) {
            System.out.println("Memo NamingException : \n" + e.getMessage());
        } catch (SQLException e) {
            System.out.println("Memo SQLException : \n" + e.getMessage());
        }
    }

}
