/*
 * Created on 2005. 4. 16. 
 */
package messanger.server;

import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import friend.Friend;
import friend.FriendHome;
import friend.temp.TmpFri;
import friend.temp.TmpFriHome;

import sequence.control.SequenceControl;
import sequence.control.SequenceControlHome;
import util.EJBHomeFactory;

import member.Member;
import member.MemberHome;
import member.dto.MemberDTO;
import messanger.MemInfo;
import messanger.client.Boneba;

/**
 *  ޽ 
 * 
 * @author BABU
 * @since 2005. 4. 16.
 */
public class BonebaServerBean implements SessionBean {
    // ڵ
    private static HashMap users;

    //  ..
    private static HashMap rooms;

    //  
    private Boneba client;

    // ش ڰ ִ 
    private Vector userRooms;

    //  ̵
    private Integer uid;

    /**
     * .
     */
    public BonebaServerBean() {
        if (users == null) {
            users = new HashMap();
        }

        if (rooms != null) {
            rooms = new HashMap();
        }
    }

    /**
     * ģ鿡 ڽ  ˸.
     * 
     * @param friends
     * @throws RemoteException
     */
    public void hiFriend(Vector friends) throws RemoteException {
        try {
            System.out.println("hiFriend() : start " + client);
            //Vector friends = client.getFriends();
            System.out.println("hiFriend() : 1111");

            if (friends != null) {
                for (int i = 0; i < friends.size(); i++) {
                    System.out.println("hiFriend() : i = " + i);
                    MemInfo memInfo = (MemInfo) friends.elementAt(i);
                    System.out.println("hiFriend() : memInfo = " + memInfo);

                    Boneba friend = (Boneba) users.get(memInfo.getUid());

                    System.out.println("hiFriend() : friend = " + friend);

                    if (friend != null) {
                        friend.alertIntoFriend(client.getInfo());
                        System.out.println("hiFriend() : alertIntoFriend");
                        friend.refreshList(getFriends(friend));
                        System.out.println("hiFriend() : refreshList");
                    }
                }
            }
        } catch (Exception e) {
            System.out.println("BonebaServerBean.hiFriend() Exception : \n"
                    + e.getMessage());
        }
    }

    /**
     * ģ߰  ޼ .
     * 
     * @param friend
     * @throws RemoteException
     */
    private void alertAddFriend(MemberDTO friend) throws RemoteException {
        // TODO ģ߰  ޼ .
    }

    /**
     * . client Ѵ.
     * 
     * @throws RemoteException
     */
    public void finish() throws RemoteException {
        users.remove(uid);

        //Vector friends = client.getFriends();

        /*
         * for (int i = 0; i < friends.size(); i++) { MemInfo memInfo =
         * (MemInfo) friends.elementAt(i); Boneba friend = (Boneba)
         * users.get(memInfo.getUid());
         * 
         * if (friend != null) { friend.refreshList(getFriends(friend)); } }
         */

        client = null;
    }

    /**
     * α
     * 
     * @param dto
     *            email passwd ־.
     * @return  ȸ MemberDTO, н null
     */
    public MemberDTO login(MemberDTO dto) throws RemoteException {
        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);
            Member member = mh.findByEmail(dto.getEmail());

            if (member.getPasswd().equals(dto.getPasswd())) {
                dto.setUid(member.getUid());
                dto.setEmail(member.getEmail());
                dto.setNickname(member.getNickname());
                dto.setPasswd("");

                uid = new Integer(member.getUid());
                users.put(uid, client);
            } else {
                dto = null;
            }
        } catch (Exception e) {
            System.err.println("login() : " + e);
            return null;
        }

        return dto;
    }

    /**
     * ģ ´.
     * 
     * @param user
     * @return MemInfo Vector
     * @throws RemoteException
     */
    public Vector getFriends(Boneba user) throws RemoteException {
        Vector friends = new Vector(10, 1);

        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();

            // Խù  
            FriendHome fh = (FriendHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/FriendHome", FriendHome.class);

            // ۼ  
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);

            // ӽ Vector
            Vector imsi = new Vector(fh.findByFriend(user.getInfo().getUid()));

            for (int i = 0; i < imsi.size(); i++) {
                Friend friend = (Friend) imsi.elementAt(i);
                Integer muid = new Integer(friend.getM_uid());
                Member member = mh.findByPrimaryKey(muid);

                MemInfo memInfo = new MemInfo();
                memInfo.setEmail(member.getEmail());
                memInfo.setNickname(member.getNickname());
                memInfo.setUid(muid);

                // ¶ 
                if (users.get(muid) != null) {
                    memInfo.setOnline(true);
                } else {
                    memInfo.setOnline(false);
                }

                friends.add(memInfo);
            }
        } catch (Exception e) {
            System.out.println("BonebaServerBean.getFriends() : \n"
                    + e.getMessage());
        }

        return friends;
    }

    /**
     * ģ ߰Ѵ.  ģ ̸ ģ θ .   ӽÿ .
     * 
     * @param email
     * @throws RemoteException
     */
    public void addFriend(String email) throws RemoteException {
        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);
            Member member = mh.findByEmail(email);

            TmpFriHome tfh = (TmpFriHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/TmpFriHome", TmpFriHome.class);

            if (member != null) {
                // Primary key 
                int imsi = -1;
                SequenceControlHome sch = (SequenceControlHome) homeFactory
                        .lookUpHome("java:comp/env/ejb/SequenceControlHome",
                                SequenceControlHome.class);
                SequenceControl sc = sch.create();
                imsi = sc.getNextPk("TmpFri");

                Integer friendUid = new Integer(member.getUid());

                tfh.create(new Integer(imsi), uid, friendUid);

                Boneba friend = (Boneba) users.get(friendUid);

                if (friend != null) {
                    friend.alertAddFriend(client.getInfo());
                }
            }
        } catch (Exception e) {
            System.err.println("addFriend() : " + e);
        }
    }

    /**
     * ڽ ߰  ִ ã´.  ˷ش.
     * 
     * @throws RemoteException
     */
    public void findAddFriend() throws RemoteException {
        try {
            EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
            TmpFriHome tfh = (TmpFriHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/TmpFriHome", TmpFriHome.class);
            Vector imsi = new Vector(tfh.findByM_uid(uid));

            MemberHome mh = (MemberHome) homeFactory.lookUpLocalHome(
                    "java:comp/env/ejb/MemberHome", MemberHome.class);

            for (int i = 0; i < imsi.size(); i++) {
                TmpFri tmpFri = (TmpFri) imsi.elementAt(i);
                Member member = mh.findByPrimaryKey(new Integer(tmpFri
                        .getF_uid()));
                MemInfo friend = new MemInfo();
                friend.setUid(new Integer(tmpFri.getF_uid()));
                friend.setEmail(member.getEmail());
                friend.setNickname(member.getNickname());

                System.out.println("uid : " + friend.getUid());
                System.out.println("email : " + friend.getEmail());
                System.out.println("nickname : " + friend.getNickname());
                System.out.println("client : " + client);

                client.alertAddFriend(friend);
            }
        } catch (Exception e) {
            System.err.println("BonebaServerBean.findAddFriend() : " + e);
        }
    }

    /**
     * ģ߰ Ѵ.
     * 
     * @param friend
     * @param flag
     * @throws RemoteException
     */
    public void acceptFriend(MemInfo friend, boolean flag)
            throws RemoteException {
        // TODO ģ߰ Ѵ.
        System.out.println("ģ߰ Ѵ. : " + flag);
    }

    /**
     * شϴ ģ Ų.
     * 
     * @param friend
     * @throws RemoteException
     */
    public void deleteFriend(MemInfo friend) throws RemoteException {
        // TODO ģ Ų.
    }

    /**
     * شϴ ģ äù 
     * 
     * @param friendID
     *            ä ģ
     * @return   Ƶ
     * @throws RemoteException
     */
    public Integer makeRoom(Integer friendID) throws RemoteException {
        BonebaServerRoom room = new BonebaServerRoom(client, (Boneba) users
                .get(friendID));
        Integer roomID = new Integer(System.identityHashCode(room));
        rooms.put(roomID, room);
        return roomID;
    }

    /**
     *  ϱ. شϴ   ڰ â    .
     * 
     * @param client
     * @throws RemoteException
     */
    public void deleteRoom(Integer roomUid) throws RemoteException {
        BonebaServerRoom room = (BonebaServerRoom) rooms.get(roomUid);

        boolean flag = true;

        for (int i = 0; i < room.users.size(); i++) {
            if (!((Boneba) room.users.elementAt(i)).isLiveRoom(roomUid)) {
                flag = false;
            }
        }

        if (flag) {
            rooms.remove(roomUid);
        }
    }

    /**
     * شϴ 濡 ޼ Ѵ.
     * 
     * @param roomUid
     * @param nickname
     * @param msg
     * @throws RemoteException
     */
    public void broadcast(Integer roomUid, String nickname, String msg)
            throws RemoteException {
        ((BonebaServerRoom) rooms.get(roomUid)).broadcast(nickname, msg);
    }

    /**
     * create
     * 
     * @param client
     * @throws CreateException
     * @throws RemoteException
     */
    public void ejbCreate(Boneba client) throws CreateException,
            RemoteException {
        this.client = client;
    }

    /**
     * @see javax.ejb.SessionBean#ejbActivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbActivate() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#ejbPassivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbPassivate() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#ejbRemove()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbRemove() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#setSessionContext(javax.ejb.SessionContext)
     * @param arg0
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void setSessionContext(SessionContext arg0) throws EJBException,
            RemoteException {
    }
}