/*
 * Created on 2005. 4. 7. 
 */
package popFolder;

import java.beans.XMLDecoder;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.rmi.RemoteException;
import java.util.Properties;
import java.util.Vector;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

/**
 *   Session Bean
 * 
 * @author BABU
 * @since 2005. 4. 7.
 */
public class PopFolderBean implements SessionBean {
    public void ejbCreate() throws CreateException, RemoteException {
    }

    /**
     *  User ROOT н ´.
     * 
     * @param uid
     * @return
     * @throws RemoteException
     */
    public String getRootPath(String uid) throws RemoteException {
        String popFolderPath = null;

        try {
            XMLDecoder xmlDecoder = new XMLDecoder(new BufferedInputStream(
                    new FileInputStream("setting.xml")));
            Properties properties = (Properties) xmlDecoder.readObject();
            xmlDecoder.close();

            popFolderPath = properties.getProperty("POPFOLDER_ROOT");
        } catch (FileNotFoundException e) {
            popFolderPath = File.separator + "PopFolder";
        }

        if (popFolderPath != null) {
            return popFolderPath + File.separator + uid;
        } else {
            return null;
        }
    }

    /**
     *  Ʈ 
     * 
     * @param targetPath
     * @return
     * @throws RemoteException
     */
    public Vector getFileList(String targetPath) throws RemoteException {
        Vector vector = null;
        File file = new File(targetPath);

        File[] list = file.listFiles();
        vector = new Vector(list.length);

        for (int i = 0; i < list.length; i++) {
            FileList fileList = new FileList();
            fileList.setAbsoulutePath(list[i].getAbsolutePath());
            fileList.setName(list[i].getName());
            fileList.setLength(list[i].length());
            fileList.setDirectory(list[i].isDirectory());
            vector.add(fileList);
        }

        return vector;
    }

    /**
     * ش  File ü 
     * 
     * @param targetPath
     * @return
     * @throws RemoteException
     */
    public FileList getFile(String targetPath) throws RemoteException {
        FileList fileList = new FileList();
        File file = new File(targetPath);

        fileList.setAbsoulutePath(file.getAbsolutePath());
        fileList.setName(file.getName());
        fileList.setLength(file.length());
        fileList.setDirectory(file.isDirectory());

        return fileList;
    }

    /**
     *  
     * 
     * @param targetPath
     * @return
     * @throws RemoteException
     */
    public boolean mkdir(String targetPath) throws RemoteException {
        File file = new File(targetPath);

        if (file.exists()) {
            return false;
        } else {
            if (file.mkdir()) {
                return true;
            } else {
                return false;
            }
        }
    }

    /**
     *  Ǵ  
     * 
     * @param targetFile
     * @return
     * @throws RemoteException
     */
    public boolean delete(String targetFile) throws RemoteException {
        File root = new File(targetFile);

        if (root.exists()) {
            if (root.isDirectory()) {
                File[] fileList = root.listFiles();

                for (int i = 0; i < fileList.length; i++) {
                    if (fileList[i].isFile()) {
                        if (!fileList[i].delete()) {
                            return false;
                        }
                    } else {
                        if (!delete(fileList[i].getAbsolutePath())) {
                            return false;
                        }
                    }
                }
            }
        }

        return root.delete();
    }

    /**
     * ̸ٲٱ
     * 
     * @param targetPath
     * @param rename
     * @return
     * @throws RemoteException
     */
    public boolean rename(String targetPath, String rename)
            throws RemoteException {
        File file = new File(targetPath);
        File newFile = new File(rename);

        return file.renameTo(newFile);
    }

    /**
     * @see javax.ejb.SessionBean#ejbActivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbActivate() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#ejbPassivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbPassivate() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#ejbRemove()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbRemove() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#setSessionContext(javax.ejb.SessionContext)
     * @param arg0
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void setSessionContext(SessionContext arg0) throws EJBException,
            RemoteException {
    }

}
