/*
 * Created on 2005. 4. 15. 
 */
package popFolder.download;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.rmi.RemoteException;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;

import popFolder.FileList;

/**
 *  ٿδ(޾ƺ)  Session Bean
 * 
 * @author BABU
 * @since 2005. 4. 15.
 */
public class DownloadBean implements SessionBean {
    public void ejbCreate() throws CreateException, RemoteException {
    }

    /**
     *  翩
     * 
     * @param path
     * @return
     * @throws RemoteException
     */
    public boolean exists(String path) throws RemoteException {
        File file = new File(path);

        if (file.exists()) {
            return false;
        } else {
            return true;
        }
    }

    /**
     *  б
     * 
     * @param bufSize
     * @param seek
     * @param file
     * @return
     * @throws RemoteException
     */
    public byte[] read(int bufSize, long seek, String file)
            throws RemoteException {
        byte[] data = null;
        RandomAccessFile raFile = null;

        try {
            raFile = new RandomAccessFile(file, "r");
            raFile.seek(seek);

            byte[] buf = new byte[bufSize];

            int size = raFile.read(buf, 0, bufSize);

            if (size > 0) {
                data = new byte[size];
                System.arraycopy(buf, 0, data, 0, size);
            }
        } catch (FileNotFoundException e) {
            System.out.println("FileNotFoundException : \n" + e.getMessage());
        } catch (IOException e) {
            System.out.println("IOException : \n" + e.getMessage());
        } finally {
            try {
                if (raFile != null) {
                    raFile.close();
                }
            } catch (IOException e1) {
                System.out.println("IOException : \n" + e1.getMessage());
            }
        }

        return data;
    }

    /**
     * ش  File ü 
     * 
     * @param path
     * @return
     * @throws RemoteException
     */
    public FileList getFile(String path) throws RemoteException {
        FileList fileList = new FileList();
        File file = new File(path);

        fileList.setAbsoulutePath(file.getAbsolutePath());
        fileList.setName(file.getName());
        fileList.setLength(file.length());
        fileList.setDirectory(file.isDirectory());

        return fileList;
    }

    /**
     * @see javax.ejb.SessionBean#ejbActivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbActivate() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#ejbPassivate()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbPassivate() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#ejbRemove()
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void ejbRemove() throws EJBException, RemoteException {
    }

    /**
     * @see javax.ejb.SessionBean#setSessionContext(javax.ejb.SessionContext)
     * @param arg0
     * @throws javax.ejb.EJBException
     * @throws java.rmi.RemoteException
     */
    public void setSessionContext(SessionContext arg0) throws EJBException,
            RemoteException {
    }

}
