package sequence.control;

import java.rmi.RemoteException;
import java.util.Hashtable;

import javax.ejb.CreateException;
import javax.ejb.EJBException;
import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import sequence.Sequence;
import sequence.SequenceHome;
import util.EJBHomeFactory;

/**
 * Sequence Block Control Bean
 * 
 * @author ٺΰ
 * @since 2005. 3. 30.
 */
public class SequenceControlBean implements SessionBean {
    private int block;

    private static Hashtable ht = new Hashtable();

    public void ejbCreate() throws RemoteException, CreateException {
        block = 10;
    }

    /**
     *  Primary key ´.
     * 
     * @param name
     * @return
     * @throws RemoteException
     */
    public int getNextPk(String name) throws RemoteException {
        int imsi = -1;

        try {
            Integer in = (Integer) ht.get(name);

            if (in == null) {
                in = new Integer(1);
                EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
                SequenceHome sh = (SequenceHome) homeFactory.lookUpLocalHome(
                        "java:comp/env/ejb/SequenceHome", SequenceHome.class);
                sh.create(name, in);
                ht.put(name, in);
            }

            if ((in.intValue() % block) == 0) {
                EJBHomeFactory homeFactory = EJBHomeFactory.getFactory();
                SequenceHome sh = (SequenceHome) homeFactory.lookUpLocalHome(
                        "java:comp/env/ejb/SequenceHome", SequenceHome.class);
                Sequence s = sh.findByPrimaryKey(name);

                s.getIncrementData(block);
            }

            imsi = in.intValue();
            ht.put(name, new Integer(imsi + 1));
        } catch (Exception ee) {
            System.err.println("getNextPk() ERROR : " + ee);
        }

        return imsi;
    }

    public void setSessionContext(SessionContext arg0) throws EJBException,
            RemoteException {
    }

    public void ejbRemove() throws EJBException, RemoteException {
    }

    public void ejbActivate() throws EJBException, RemoteException {
    }

    public void ejbPassivate() throws EJBException, RemoteException {
    }
}