//Created by MyEclipse Struts
// XSL source (default): platform:/plugin/com.genuitec.eclipse.cross.easystruts.eclipse_3.8.4/xslt/JavaClass.xsl

package babu.struts.action;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.upload.FormFile;

import babu.model.BoardDTO;
import babu.model.BoardManager;
import babu.struts.form.WriteForm;

/**
 * MyEclipse Struts Creation date: 06-28-2005
 * 
 * XDoclet definition:
 * 
 * @struts:action path="/write" name="writeForm" input="/form/write.jsp"
 *                scope="request" validate="true"
 * @struts:action-forward name="success" path="/form/list.jsp"
 *                        contextRelative="true"
 * @struts:action-forward name="fail" path="/form/error.jsp"
 *                        contextRelative="true"
 */
public class WriteAction extends Action {

    // --------------------------------------------------------- Instance
    // Variables

    // --------------------------------------------------------- Methods

    /**
     * Method execute
     * 
     * @param mapping
     * @param form
     * @param request
     * @param response
     * @return ActionForward
     */
    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response) {
        WriteForm writeForm = (WriteForm) form;

        String title = writeForm.getTitle();
        String name = writeForm.getName();
        String contents = writeForm.getContents();
        FormFile file = writeForm.getFilename();
        String filename = file.getFileName();

        BoardDTO dto = new BoardDTO(0L, title, name, contents, filename);
        BoardManager manager = BoardManager.getInstance();

        if (!manager.create(dto)) {
            return mapping.findForward("fail");
        }

        File dir = new File("D:\\upload");
        if (!dir.exists()) {
            dir.mkdir();
        }

        File upFile = new File(dir, filename);
        DataOutputStream dos = null;
        DataInputStream dis = null;

        try {
            dos = new DataOutputStream(new BufferedOutputStream(
                    new FileOutputStream(upFile)));
            dis = new DataInputStream(new BufferedInputStream(file
                    .getInputStream()));

            byte[] buf = new byte[1024];
            int len = 0;

            while ((len = dis.read(buf, 0, len)) > 0) {
                dos.write(buf, 0, len);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                if (dis != null) {
                    dis.close();
                }
                if (dos != null) {
                    dos.close();
                }
            } catch (IOException e1) {
                e1.printStackTrace();
            }
        }

        return mapping.findForward("success");
    }

}