/*
 * Created on 2005. 4. 17. 
 */
package messanger.client;

import java.rmi.RemoteException;
import java.util.HashMap;
import java.util.Properties;
import java.util.Vector;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.JOptionPane;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

import member.dto.MemberDTO;
import messanger.MemInfo;
import messanger.server.BonebaServer;
import messanger.server.BonebaServerHome;

/**
 * Boneba Interface 
 * 
 * @author BABU
 * @since 2005. 4. 17.
 */
public class BonebaImpl implements Boneba {
    private MemInfo memInfo = null;

    private BonebaServer server = null;

    private BonebaMessanger messanger;

    private Vector friends;

    private HashMap rooms;

    public BonebaImpl(BonebaMessanger messanger) {
        this.messanger = messanger;
        rooms = new HashMap();
    }

    /**
     * α
     * 
     * @param email
     * @param password
     * @return
     */
    public boolean Login(String email, String password) {
        boolean flag = false;

        try {
            Properties prop = new Properties();
            prop.put("javax.rmi.CORBA.UtilClass",
                    "com.sun.corba.ee.impl.javax.rmi.CORBA.Util");
            prop.put("org.omg.CORBA.ORBClass",
                    "com.sun.corba.ee.impl.orb.ORBImpl");
            prop.put("org.omg.CORBA.ORBSingletonClass",
                    "com.sun.corba.ee.impl.orb.ORBSingleton");
            prop.put("java.naming.factory.initial",
                    "com.sun.jndi.cosnaming.CNCtxFactory");
            prop.put("org.omg.CORBA.ORBInitialHost", "218.39.199.58");
            //prop.put("org.omg.CORBA.ORBInitialHost", "localhost");
            prop.put("org.omg.CORBA.ORBInitialPort", "3700");

            PortableRemoteObject.exportObject(this);
            InitialContext ctx = new InitialContext(prop);

            BonebaServerHome bsh = (BonebaServerHome) PortableRemoteObject
                    .narrow(ctx.lookup("BonebaServerBean"),
                            BonebaServerHome.class);

            server = bsh.create(this);

            MemberDTO dto = new MemberDTO();
            dto.setEmail(email);
            dto.setPasswd(password);

            if ((dto = server.login(dto)) != null) {
                memInfo = new MemInfo();
                memInfo.setUid(new Integer(dto.getUid()));
                memInfo.setEmail(dto.getEmail());
                memInfo.setNickname(dto.getNickname());
                memInfo.setOnline(true);

                flag = true;
            } else {
                return false;
            }
        } catch (Exception e) {
            System.err.println("Login() : " + e);
        }

        return flag;
    }

    public void sendMsg(Integer roomID, String msg) {
        try {
            server.broadcast(roomID, memInfo.getNickname(), msg);
        } catch (RemoteException e) {
            System.out.println("sendMsg() RemoteException : \n"
                    + e.getMessage());
        }
    }

    /**
     * ڽ ߰  ã´.
     */
    public void findAddFriend() {
        System.out.println("ģ ã");
        try {
            server.findAddFriend();
        } catch (RemoteException e) {
            System.out.println("findAddFriend() RemoteException : \n"
                    + e.getMessage());
        }
    }

    /**
     * α׾ƿ
     */
    public void logout() {
        try {
            server.finish();
        } catch (RemoteException e) {
            System.out
                    .println("logout() RemoteException : \n" + e.getMessage());
        }
    }

    /**
     * ģ ߰
     * 
     * @param email
     */
    public void addFriend(String email) {
        try {
            server.addFriend(email);
        } catch (RemoteException e) {
            System.out.println("addFriend() RemoteException : \n"
                    + e.getMessage());
        }
    }

    /**
     * ģ ߰ ˸
     * 
     * @param info
     */
    public void alertAddFriend(MemInfo info) throws RemoteException {
        System.out.println("ģ ߰ ˸");

        if (JOptionPane.showConfirmDialog(messanger, info.getEmail()
                + "\nģ߰ û Ͽϴ.\nϽðڽϱ?", "ģ߰ û",
                JOptionPane.YES_NO_OPTION) == 0) {
            server.acceptFriend(info, true);
        } else {
            server.acceptFriend(info, false);
        }
    }

    public DefaultTreeModel makeList() {
        DefaultTreeModel treeModel = null;

        try {
            if (friends != null) {
                friends = null;
            }

            friends = server.getFriends(this);

            DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode(
                    "boneba");
            DefaultMutableTreeNode onlineNode = new DefaultMutableTreeNode(
                    "¶");
            rootNode.add(onlineNode);
            DefaultMutableTreeNode offlineNode = new DefaultMutableTreeNode(
                    "");
            rootNode.add(offlineNode);

            for (int i = 0; i < friends.size(); i++) {
                MemInfo friend = (MemInfo) friends.elementAt(i);
                if (friend.isOnline()) {
                    onlineNode.add(new DefaultMutableTreeNode(friend
                            .getNickname()));
                } else {
                    offlineNode.add(new DefaultMutableTreeNode(friend
                            .getNickname()));
                }
            }

            treeModel = new DefaultTreeModel(rootNode);
        } catch (RemoteException e) {
            System.out.println("makeList() RemoteException : \n"
                    + e.getMessage());
        }

        return treeModel;
    }

    /**
     * @see messanger.client.Boneba#getInfo()
     * @return
     * @throws RemoteException
     */
    public MemInfo getInfo() throws RemoteException {
        return memInfo;
    }

    /**
     * @see messanger.client.Boneba#isLiveRoom(java.lang.Integer)
     * @param roomUid
     * @return
     * @throws RemoteException
     */
    public boolean isLiveRoom(Integer roomUid) throws RemoteException {
        // TODO Auto-generated method stub
        return false;
    }

    /**
     * @see messanger.client.Boneba#refreshList(java.util.Vector)
     * @param friends
     * @throws RemoteException
     */
    public void refreshList(Vector friends) throws RemoteException {
        System.out.println("refreshList()..");
        try {
            DefaultMutableTreeNode rootNode = new DefaultMutableTreeNode(
                    "boneba");
            DefaultMutableTreeNode onlineNode = new DefaultMutableTreeNode(
                    "¶");
            rootNode.add(onlineNode);
            DefaultMutableTreeNode offlineNode = new DefaultMutableTreeNode(
                    "");
            rootNode.add(offlineNode);

            for (int i = 0; i < friends.size(); i++) {
                MemInfo friend = (MemInfo) friends.elementAt(i);
                if (friend.isOnline()) {
                    onlineNode.add(new DefaultMutableTreeNode(friend
                            .getNickname()));
                } else {
                    offlineNode.add(new DefaultMutableTreeNode(friend
                            .getNickname()));
                }
            }

            DefaultTreeModel treeModel = new DefaultTreeModel(rootNode);
            messanger.jTree.setModel(treeModel);
            messanger.jTree.updateUI();
        } catch (Exception e) {
            System.out.println("Exception : \n" + e.getMessage());
        }
    }

    /**
     * @see messanger.client.Boneba#getFriends()
     * @return
     * @throws RemoteException
     */
    public Vector getFriends() throws RemoteException {
        return friends;
    }

    /**
     * λ
     */
    public void hiFriend() {
        /*
         * try { server.hiFriend(friends); } catch (RemoteException e) {
         * System.out.println("hiFriend()RemoteException : \n" +
         * e.getMessage()); }
         */
    }

    /**
     * @see messanger.client.Boneba#alertIntoFriend(messanger.MemInfo)
     * @param friend
     * @throws RemoteException
     */
    public void alertIntoFriend(MemInfo friend) throws RemoteException {
        JOptionPane.showMessageDialog(messanger, friend.getNickname()
                + " !!");
    }

    /**
     * @param name
     */
    public void startChat(String name) {
        MemInfo friend = null;

        for (int i = 0; i < friends.size(); i++) {
            if (((MemInfo) friends.elementAt(i)).getNickname().equals(name)) {
                friend = (MemInfo) friends.elementAt(i);
                i = friends.size() + 1;
            }
        }

        new BonebaWin(this, " ޽ - " + friend.getNickname() + "԰ ȭ",
                new Integer(1), friend);

        /*
         * try { Integer roomID = server.makeRoom(friend.getUid());
         * 
         * if (rooms.get(roomID) == null) { rooms.put(roomID, new
         * BonebaWin(this, " ޽ - " + friend.getNickname() + "԰ ȭ",
         * roomID, friend)); } else { ((BonebaWin)
         * rooms.get(roomID)).setVisible(true); } } catch (RemoteException e) {
         * System.out.println("startChat() RemoteException : \n" +
         * e.getMessage()); }
         */
    }

    /**
     * @see messanger.client.Boneba#addMsg(java.lang.Integer, java.lang.String)
     * @param roomID
     * @param msg
     * @throws RemoteException
     */
    public void addMsg(Integer roomID, String msg) throws RemoteException {
        BonebaWin chatWin = (BonebaWin) rooms.get(roomID);

        chatWin.setVisible(true);
        chatWin.jTextArea.append(msg);
    }
}
