/*
 * Created on 2005. 4. 15. 
 */
package viewer.jframe;

import javax.swing.JFrame;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JTable;
import javax.swing.JScrollPane;
import java.awt.GridLayout;
import java.io.File;

import javax.swing.JButton;

import javax.swing.JTextField;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import babu.table.BABUTableModel;

/**
 * ޾ƺ
 * 
 * @author BABU
 * @since 2005. 4. 15.
 */
public class DownLoader extends JFrame {
    private DownLoaderControl control;

    private boolean isDownload = false;

    private javax.swing.JPanel jContentPane = null;

    private JPanel jPanel = null;

    public JProgressBar jProgressBar = null;

    private JTable jTable = null;

    private JScrollPane jScrollPane = null;

    private JPanel jPanel1 = null;

    private JPanel jPanel2 = null;

    private JPanel jPanel3 = null;

    private JButton btnSavepath = null;

    private JButton btnDelete = null;

    public JButton btnDownload = null;

    public JTextField jTextField = null;

    public BABUTableModel model = null; //  @jve:decl-index=0:

    /**
     * This is the default constructor
     */
    public DownLoader(String rootPath) {
        super();

        control = new DownLoaderControl(this, rootPath);

        if (control.connect()) {
            initialize();
        }
    }

    /**
     * This method initializes this
     * 
     * @return void
     */
    private void initialize() {
        this.setSize(400, 250);
        this.setLocationRelativeTo(this);
        this.setContentPane(getJContentPane());
        this.setTitle("޾ƺ");
        this.setVisible(true);
        this.addComponentListener(new java.awt.event.ComponentAdapter() {
            public void componentResized(java.awt.event.ComponentEvent e) {
                eventResize();
            }
        });
    }

    public void eventResize() {
        if (this.getWidth() < 400) {
            this.setSize(400, this.getHeight());
        }

        if (this.getHeight() < 250) {
            this.setSize(this.getWidth(), 250);
        }

        jProgressBar.setPreferredSize(new java.awt.Dimension(
                this.getWidth() - 20, 24));
        jProgressBar.updateUI();

        jTextField.setPreferredSize(new java.awt.Dimension(
                this.getWidth() - 107, 24));
        jTextField.updateUI();
    }

    /**
     * This method initializes jContentPane
     * 
     * @return javax.swing.JPanel
     */
    private javax.swing.JPanel getJContentPane() {
        if (jContentPane == null) {
            jContentPane = new javax.swing.JPanel();
            jContentPane.setLayout(new java.awt.BorderLayout());
            jContentPane.add(getJPanel(), java.awt.BorderLayout.NORTH);
            jContentPane.add(getJScrollPane(), java.awt.BorderLayout.CENTER);
            jContentPane.add(getJPanel1(), java.awt.BorderLayout.SOUTH);
        }
        return jContentPane;
    }

    /**
     * This method initializes jPanel
     * 
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel() {
        if (jPanel == null) {
            jPanel = new JPanel();
            jPanel.add(getJProgressBar(), null);
        }
        return jPanel;
    }

    /**
     * This method initializes jProgressBar
     * 
     * @return javax.swing.JProgressBar
     */
    private JProgressBar getJProgressBar() {
        if (jProgressBar == null) {
            jProgressBar = new JProgressBar();
            jProgressBar.setPreferredSize(new java.awt.Dimension(this
                    .getWidth() - 20, 24));
            jProgressBar.setStringPainted(true);
        }
        return jProgressBar;
    }

    /**
     * This method initializes jTable
     * 
     * @return javax.swing.JTable
     */
    private JTable getJTable() {
        if (jTable == null) {
            jTable = new JTable();
            jTable.setModel(getModel());
            jTable.getSelectionModel().addListSelectionListener(
                    new ListSelectionListener() {
                        public void valueChanged(ListSelectionEvent e) {
                            selectedList();
                        }
                    });
        }
        return jTable;
    }

    /**
     * Ʈ õǾ 
     */
    private void selectedList() {
        if (isDownload) {
            jTable.clearSelection();
        } else if (jTable.getSelectedRow() >= 0) {
            btnDelete.setEnabled(true);
        }
    }

    /**
     * This method initializes jScrollPane
     * 
     * @return javax.swing.JScrollPane
     */
    private JScrollPane getJScrollPane() {
        if (jScrollPane == null) {
            jScrollPane = new JScrollPane();
            jScrollPane.setViewportView(getJTable());
        }
        return jScrollPane;
    }

    /**
     * This method initializes jPanel1
     * 
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel1() {
        if (jPanel1 == null) {
            GridLayout gridLayout1 = new GridLayout();
            jPanel1 = new JPanel();
            jPanel1.setLayout(gridLayout1);
            gridLayout1.setRows(2);
            jPanel1.add(getJPanel2(), null);
            jPanel1.add(getJPanel3(), null);
        }
        return jPanel1;
    }

    /**
     * This method initializes jPanel2
     * 
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel2() {
        if (jPanel2 == null) {
            jPanel2 = new JPanel();
            jPanel2.add(getJTextField(), null);
            jPanel2.add(getBtnSavepath(), null);
        }
        return jPanel2;
    }

    /**
     * This method initializes jPanel3
     * 
     * @return javax.swing.JPanel
     */
    private JPanel getJPanel3() {
        if (jPanel3 == null) {
            jPanel3 = new JPanel();
            jPanel3.add(getBtnDelete(), null);
            jPanel3.add(getBtnDownload(), null);
        }
        return jPanel3;
    }

    /**
     * This method initializes jButton
     * 
     * @return javax.swing.JButton
     */
    private JButton getBtnSavepath() {
        if (btnSavepath == null) {
            btnSavepath = new JButton();
            btnSavepath.setText("ġ");
            btnSavepath.setPreferredSize(new java.awt.Dimension(85, 24));
            btnSavepath.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    setSavePath();
                }
            });
        }
        return btnSavepath;
    }

    private void setSavePath() {
        JFileChooser jFileChooser = new JFileChooser();
        jFileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);

        if (jFileChooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            File file = jFileChooser.getSelectedFile();
            jTextField.setText(file.getAbsolutePath());
        }
    }

    /**
     * This method initializes jButton1
     * 
     * @return javax.swing.JButton
     */
    private JButton getBtnDelete() {
        if (btnDelete == null) {
            btnDelete = new JButton();
            btnDelete.setText("");
            btnDelete.setEnabled(false);
            btnDelete.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    deleteFile();
                }
            });
        }
        return btnDelete;
    }

    /**
     * Ͽ  
     */
    private void deleteFile() {
        int selectedRow = jTable.getSelectedRow();

        model.removeRow(selectedRow);
        jTable.clearSelection();
        btnDelete.setEnabled(false);

        if (model.getRowCount() == 0) {
            btnDownload.setEnabled(false);
        }
    }

    /**
     * This method initializes jButton2
     * 
     * @return javax.swing.JButton
     */
    private JButton getBtnDownload() {
        if (btnDownload == null) {
            btnDownload = new JButton();
            btnDownload.setText("ٿε");
            btnDownload.setEnabled(false);
            btnDownload.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(java.awt.event.ActionEvent e) {
                    startDownload();
                }
            });
        }
        return btnDownload;
    }

    private void startDownload() {
        if (jTextField.getText().length() > 0) {
            isDownload = true;

            btnDownload.setText("");
            btnDelete.setEnabled(false);
            btnSavepath.setEnabled(false);
            jTable.clearSelection();

            control.start();
        } else {
            JOptionPane.showMessageDialog(this, "ġ Ͻʽÿ.");
        }
    }

    private void stopDownload() {
        isDownload = false;

        btnDownload.setText("ٿε");
        btnDelete.setEnabled(false);
        btnSavepath.setEnabled(true);
        jTable.clearSelection();
    }

    /**
     * This method initializes jTextField
     * 
     * @return javax.swing.JTextField
     */
    private JTextField getJTextField() {
        if (jTextField == null) {
            jTextField = new JTextField();
            jTextField.setPreferredSize(new java.awt.Dimension(
                    this.getWidth() - 107, 24));
            jTextField.setEnabled(false);
        }
        return jTextField;
    }

    /**
     * This method initializes model
     * 
     * @return babu.table.BABUTableModel
     */
    private BABUTableModel getModel() {
        if (model == null) {
            model = new BABUTableModel();
            model.addColumn("ϸ");
            model.addColumn("ũ");
            model.addColumn("ũ");
            model.addColumn("");
            model.addColumn("ü");
            model.setCellEditable(false);
        }
        return model;
    }

    /**
     *  
     */
    public void downloadComplete() {
        JOptionPane.showMessageDialog(this, "ۿϷǾϴ.");

        stopDownload();

        model.removeAllRow();
        btnDownload.setEnabled(false);
    }
}
