/*
 * Created on 2005. 4. 15. 
 */
package viewer.jframe;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.rmi.RemoteException;
import java.util.Properties;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

import popFolder.FileList;
import popFolder.download.Download;
import popFolder.download.DownloadHome;

/**
 * Downloader  Ʈѷ
 * 
 * @author BABU
 * @since 2005. 4. 15.
 */
public class DownLoaderControl implements Runnable {
    private boolean isDownloading = false;

    private Thread thread = null;

    private final static int bufSize = 512;

    private Download download = null;

    private DownLoader downloader = null;

    private String rootPath = null;

    public String savePath = File.separator;

    /**
     * 
     * 
     * @param uploader
     * @param rootPath
     */
    public DownLoaderControl(DownLoader downloader, String rootPath) {
        this.downloader = downloader;
        this.rootPath = rootPath;
    }

    /**
     * EJB Ѵ.
     * 
     * @return
     */
    public boolean connect() {
        boolean flag = false;

        try {
            Properties prop = new Properties();
            prop.put("javax.rmi.CORBA.UtilClass",
                    "com.sun.corba.ee.impl.javax.rmi.CORBA.Util");
            prop.put("org.omg.CORBA.ORBClass",
                    "com.sun.corba.ee.impl.orb.ORBImpl");
            prop.put("org.omg.CORBA.ORBSingletonClass",
                    "com.sun.corba.ee.impl.orb.ORBSingleton");
            prop.put("java.naming.factory.initial",
                    "com.sun.jndi.cosnaming.CNCtxFactory");
            prop.put("org.omg.CORBA.ORBInitialHost", "218.39.199.58");
            prop.put("org.omg.CORBA.ORBInitialPort", "3700");

            InitialContext ctx = new InitialContext(prop);

            DownloadHome dh = (DownloadHome) PortableRemoteObject.narrow(ctx
                    .lookup("DownloadBean"), DownloadHome.class);

            download = dh.create();

            flag = true;
        } catch (Exception e) {
            System.err.println("DownLoaderControl.connect() : " + e);
        }

        return flag;
    }

    public void start() {
        isDownloading = true;
        thread = new Thread(this);
        thread.start();
    }

    public void stop() {
        isDownloading = false;

        if (thread == Thread.currentThread()) {
            thread.stop();
            thread = null;
        }
    }

    /**
     * @see java.lang.Runnable#run()
     *  
     */
    public void run() {
        startDownload();
    }

    /**
     * download 
     */
    public void startDownload() {
        int rowCount = downloader.model.getRowCount();
        String savePath = downloader.jTextField.getText();
        downloader.jProgressBar.setString("0 % غ..");
        downloader.jProgressBar.setMaximum(rowCount);
        FileList[] list = new FileList[rowCount];
        int totalCount = 0;

        //  غ
        for (int i = 0; i < rowCount; i++) {
            if (!isDownloading) {
                return;
            }

            downloader.jProgressBar.setValue(i + 1);
            downloader.jProgressBar.setString((int) (downloader.jProgressBar
                    .getPercentComplete() * 100)
                    + " % غ..");
            try {
                list[i] = download.getFile(rootPath
                        + (String) downloader.model.getValueAt(i, 4));
            } catch (RemoteException e) {
                System.out.println("RemoteException : \n" + e.getMessage());
            }
            totalCount += (int) (list[i].getLength() / bufSize);

            if ((list[i].getLength() % bufSize) > 0) {
                totalCount++;
            }
        }

        downloader.jProgressBar.setMaximum(totalCount);
        int current = 0;
        downloader.jProgressBar.setValue(current++);
        downloader.jProgressBar.setString((int) (downloader.jProgressBar
                .getPercentComplete() * 100)
                + " % Ϸ");
        RandomAccessFile receiveFile = null;

        for (int i = 0; i < rowCount; i++) {
            //  
            try {
                String filename = savePath + File.separator + list[i].getName();
                receiveFile = new RandomAccessFile(filename, "rw");
                long fileSize = list[i].getLength();
                long downSize = 0;

                int count = 0;

                byte[] buf = null;

                while ((buf = download.read(bufSize, count * bufSize, list[i]
                        .getAbsoulutePath())) != null) {
                    if (!isDownloading) {
                        return;
                    }

                    receiveFile.write(buf, 0, buf.length);
                    count++;

                    downSize += buf.length;
                    downloader.model.setValueAt(new Long(downSize), i, 2);
                    downloader.model.setValueAt(
                            (int) (downSize * 100 / fileSize) + "%", i, 3);
                    downloader.jProgressBar.setValue(current++);
                    downloader.jProgressBar
                            .setString((int) (downloader.jProgressBar
                                    .getPercentComplete() * 100)
                                    + " % Ϸ");
                }
            } catch (FileNotFoundException e) {
                System.out.println("FileNotFoundException : \n"
                        + e.getMessage());
            } catch (IOException e) {
                System.out.println("IOException : \n" + e.getMessage());
            } finally {
                try {
                    if (receiveFile != null) {
                        receiveFile.close();
                    }
                } catch (IOException e1) {
                    System.out.println("IOException : \n" + e1.getMessage());
                }
            }
        }

        //  Ϸ
        downloader.downloadComplete();
    }
}