/*
 * Created on 2005. 4. 14. 
 */
package viewer.jframe;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;

import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

import popFolder.FileList;
import popFolder.upload.Upload;
import popFolder.upload.UploadHome;

/**
 * Uploader  Ʈѷ
 * 
 * @author BABU
 * @since 2005. 4. 14.
 */
public class UploaderControl implements Runnable {
    private boolean isUploading = false;

    private Thread thread = null;

    private final static int bufSize = 512;

    private Upload upload = null;

    private UpLoader uploader = null;

    private String rootPath = null;

    public String savePath = File.separator;

    /**
     * 
     * 
     * @param uploader
     * @param rootPath
     */
    public UploaderControl(UpLoader uploader, String rootPath) {
        this.uploader = uploader;
        this.rootPath = rootPath;
    }

    /**
     *  θ 
     * 
     * @return
     */
    public void setPath(String path) {
        this.savePath = path;
        uploader.setPath("ġ:" + savePath);
    }

    /**
     * EJB Ѵ.
     * 
     * @return
     */
    public boolean connect() {
        boolean flag = false;

        try {
            Properties prop = new Properties();
            prop.put("javax.rmi.CORBA.UtilClass",
                    "com.sun.corba.ee.impl.javax.rmi.CORBA.Util");
            prop.put("org.omg.CORBA.ORBClass",
                    "com.sun.corba.ee.impl.orb.ORBImpl");
            prop.put("org.omg.CORBA.ORBSingletonClass",
                    "com.sun.corba.ee.impl.orb.ORBSingleton");
            prop.put("java.naming.factory.initial",
                    "com.sun.jndi.cosnaming.CNCtxFactory");
            prop.put("org.omg.CORBA.ORBInitialHost", "218.39.199.58");
            prop.put("org.omg.CORBA.ORBInitialPort", "3700");

            InitialContext ctx = new InitialContext(prop);

            UploadHome uh = (UploadHome) PortableRemoteObject.narrow(ctx
                    .lookup("UploadBean"), UploadHome.class);

            upload = uh.create();

            flag = true;
        } catch (Exception e) {
            System.err.println("UploaderControl.connect() : " + e);
        }

        return flag;
    }

    public void start() {
        isUploading = true;
        thread = new Thread(this);
        thread.start();
    }

    public void stop() {
        isUploading = false;

        if (thread == Thread.currentThread()) {
            thread.stop();
            thread = null;
        }
    }

    /**
     * @see java.lang.Runnable#run()
     *  
     */
    public void run() {
        startUpload();
    }

    /**
     * @param path
     */
    public void getFolderList(TreePath path) {
        try {
            String filePath = rootPath;
            StringTokenizer st = new StringTokenizer(path.toString(), "[,]");

            if (st.countTokens() > 1) {
                st.nextToken();

                while (st.hasMoreTokens()) {
                    filePath = filePath + File.separator
                            + st.nextToken().trim();
                }
            }

            DefaultMutableTreeNode selnode = (DefaultMutableTreeNode) path
                    .getLastPathComponent();
            selnode.removeAllChildren();

            // ϴ Ʈ 
            Vector vector = upload.getFolderList(filePath);

            for (int i = 0; i < vector.size(); i++) {
                FileList fileList = (FileList) vector.elementAt(i);

                DefaultMutableTreeNode node = new DefaultMutableTreeNode(
                        fileList.getName());
                selnode.add(node);
            }

            //viewer.jTree.updateUI();
            //viewer.jTable.updateUI();
        } catch (Exception e) {
            System.out.println("UploaderControl getFolderList() : " + e);
        }
    }

    /**
     * @param path
     */
    public void selectPath(TreePath path) {
        try {
            String filePath = "";
            StringTokenizer st = new StringTokenizer(path.toString(), "[,]");

            if (st.countTokens() > 1) {
                st.nextToken();

                while (st.hasMoreTokens()) {
                    filePath = filePath + File.separator
                            + st.nextToken().trim();
                }
            }

            setPath(filePath);
        } catch (Exception e) {
            System.out.println("UploaderControl selectPath() : " + e);
        }
    }

    /**
     * upload 
     */
    public void startUpload() {
        int rowCount = uploader.model.getRowCount();
        uploader.jProgressBar.setString("0 % غ..");
        uploader.jProgressBar.setMaximum(rowCount);
        File[] list = new File[rowCount];
        int totalCount = 0;

        //  غ
        for (int i = 0; i < rowCount; i++) {
            if (!isUploading) {
                return;
            }

            uploader.jProgressBar.setValue(i + 1);
            uploader.jProgressBar.setString((int) (uploader.jProgressBar
                    .getPercentComplete() * 100)
                    + " % غ..");
            list[i] = new File((String) uploader.model.getValueAt(i, 4));
            totalCount += (int) (list[i].length() / bufSize);

            if ((list[i].length() % bufSize) > 0) {
                totalCount++;
            }
        }

        uploader.jProgressBar.setMaximum(totalCount);
        int current = 0;
        uploader.jProgressBar.setValue(current++);
        uploader.jProgressBar.setString((int) (uploader.jProgressBar
                .getPercentComplete() * 100)
                + " % Ϸ");
        byte[] buf = new byte[bufSize];
        RandomAccessFile sendFile = null;

        for (int i = 0; i < rowCount; i++) {
            //  
            try {
                String filename = list[i].getName();
                sendFile = new RandomAccessFile(list[i], "r");
                long fileSize = sendFile.length();
                long upSize = 0;

                int count = 0;
                int len = 0;

                while ((len = sendFile.read(buf)) > 0) {
                    if (!isUploading) {
                        return;
                    }

                    upload.write(buf, 0, len, count * bufSize, this.rootPath
                            + this.savePath + filename);
                    count++;

                    upSize += len;
                    uploader.model.setValueAt(new Long(upSize), i, 2);
                    uploader.model.setValueAt((int) (upSize * 100 / fileSize)
                            + "%", i, 3);
                    uploader.jProgressBar.setValue(current++);
                    uploader.jProgressBar
                            .setString((int) (uploader.jProgressBar
                                    .getPercentComplete() * 100)
                                    + " % Ϸ");
                }
            } catch (FileNotFoundException e) {
                System.out.println("FileNotFoundException : \n"
                        + e.getMessage());
            } catch (IOException e) {
                System.out.println("IOException : \n" + e.getMessage());
            } finally {
                try {
                    if (sendFile != null) {
                        sendFile.close();
                    }
                } catch (IOException e1) {
                    System.out.println("IOException : \n" + e1.getMessage());
                }
            }
        }

        //  Ϸ
        uploader.uploadComplete();
    }
}
